"use strict";
window.GirlsGame.state.boot = {
    enterIncorrectOrientation: function(){
        $('#orientationBckg').show();
        $('#orientationBckg').width(window.innerWidth);
        $('#orientationBckg').height(window.innerHeight);
        $('#orientation').show();
        // $('#orientation').width(window.innerWidth);
        // $('#orientation').height(window.innerHeight);
    },
    leaveIncorrectOrientation: function(){
        $('#orientationBckg').hide();
        $('#orientation').hide();
    },
    preload: function(){
        // set world size
        this.game.world.setBounds(0, 0, gameWidth, gameHeight);
        this.game.stage.disableVisibilityChange = true;
        
        this.game.scale.parentIsWindow = (this.game.canvas.parentNode == document.body);

        if (this.game.device.desktop === false)
        {
            this.game.scale.fullScreenScaleMode = Phaser.ScaleManager.EXACT_FIT;
        }

        function gameResized(manager, bounds)
        {
            var w = window.innerWidth / this.game.width;
            var h = window.innerHeight / this.game.height;
            // var scale = Math.min(window.innerWidth / this.game.width, window.innerHeight / this.game.height);

            if(window.innerHeight > window.innerWidth && this.game.device.desktop === false){
                this.enterIncorrectOrientation();
            }
            else{
                this.leaveIncorrectOrientation();
            }
         
            manager.setUserScale(w, h, 0, 0);
        }

        if (this.game.device.desktop === false){
            this.game.scale.forceLandscape = true;
            this.game.scale.scaleMode = Phaser.ScaleManager.USER_SCALE;
            this.game.scale.setResizeCallback(gameResized, this);

            this.game.scale.enterIncorrectOrientation.add(this.enterIncorrectOrientation, this);
            this.game.scale.leaveIncorrectOrientation.add(this.leaveIncorrectOrientation, this);

            if(this.game.scale.isPortrait){
                this.enterIncorrectOrientation();
            }
        }
        else{
            this.game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        }

        this.game.load.image('sky_bckg', 'assets/sprites/sky.png');
        this.game.load.image('logo', 'assets/sprites/logo.png');
        this.game.load.image('loading_bar', 'assets/sprites/loading_bar.png');
        this.game.load.image('loading_bar_fill', 'assets/sprites/loading_bar_fill.png');
        this.game.load.image('preloader_play_btn', 'assets/sprites/preloader_play_btn.png');
        this.game.load.image('pets_btn', 'assets/sprites/pets.png');
        this.game.load.image('dress_up_btn', 'assets/sprites/dress-up.png');
        this.game.load.image('decoration_btn', 'assets/sprites/decoration.png');
        this.game.load.image('make_up_btn', 'assets/sprites/make-up.png');
        this.game.load.image('cooking_btn', 'assets/sprites/cooking.png');
        this.game.load.image('wedding_btn', 'assets/sprites/wedding.png');
    },
    create: function(){
        // add all game states
        for(var stateName in window.GirlsGame.state){
            this.game.state.add(stateName, window.GirlsGame.state[stateName]);
        }

        this.game.audioState = true;
        
        // goto load state
        this.game.state.start("load");
    }
};