"use strict";
var manager = null;
var emitter = null;
window.GirlsGame.state.level1 = {
    game: window.GirlsGame.game,
    hiddenParticles: [],
    btnHoverBubble: function(el, shadow){
        var self = this;
        var stepTime = 75;
        var t = this.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.3}, stepTime, Phaser.Easing.Bounce.None);
        t.start();

        setTimeout(function(){
            var t2 = self.game.add.tween(el.scale);
            t2.to({x: 0.3, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
            t2.start();

            setTimeout(function(){
                var t3 = self.game.add.tween(el.scale);
                t3.to({x: 0.5, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
                t3.onComplete.addOnce(function(){
                    if(el.hovered && shadow){
                        var t4 = self.game.add.tween(shadow);
                        t4.to({alpha: 1}, stepTime * 3, Phaser.Easing.Linear.None);
                        t4.start();
                    }
                }, this);
                t3.start();

            }, stepTime);
        }, stepTime);

    },
    btnPressed: function(el){
        var uri = null;
        if(el.name == 'fb'){
            uri = fbUri;
        }
        if(el.name == 'logo'){
            uri = logoUri
        }
        if(el.name == 'plus'){
            uri = plusUri
        }

        var win = window.open(uri, '_blank');
        win.focus();
    },
    hiddenPressed: function(el){
        var self = window.GirlsGame.state.level1;
        if(self.game.audioState) self.game.hiddenEffectAudio.play();
        self.hiddenParticles.push(el);

        el.bringToTop();
        var t0 = this.game.add.tween(el);
        t0.to({y: el.y - gameHeight * 0.03}, 200, Phaser.Easing.Linear.None);
        t0.onComplete.addOnce(function(){
            if(self.items.indexOf(el) > -1){
                self.items.splice(self.items.indexOf(el), 1);
            }
            var t = self.game.add.tween(el.scale);
            t.to({x: 0.2, y: 0.2}, 800, Phaser.Easing.Linear.None);
            t.start();

            var t2 = self.game.add.tween(el);
            t2.to({x:  gameWidth * 0.345, y: gameHeight * 0.636}, 800, Phaser.Easing.Linear.None);
            t2.start();

            var t3 = self.game.add.tween(el);
            t3.to({alpha: 0}, 800, Phaser.Easing.Linear.None);
            t3.start();

            var t4 = self.game.add.tween(el);
            t4.to({angle: 1800}, 800, Phaser.Easing.Linear.None);
            t4.onComplete.addOnce(function(){
                if(el.name == 'pie'){
                    el.scale.setTo(0.2);
                    el.x = gameWidth * 0.3;
                    el.y = gameHeight * 0.635;
                    el.angle = 90;
                    el.alpha = 1;
                }

                if(el.name == 'obj2'){
                    el.scale.setTo(0.22);
                    el.x = gameWidth * 0.342;
                    el.y = gameHeight * 0.655;
                    el.alpha = 1;
                }

                if(el.name == 'obj3'){
                    el.scale.setTo(0.17);
                    el.x = gameWidth * 0.345;
                    el.y = gameHeight * 0.636;
                    el.alpha = 1;
                }

                if(el.name == 'obj7'){
                    el.scale.setTo(0.35);
                    el.x = gameWidth * 0.36;
                    el.y = gameHeight * 0.655;
                    el.angle = 75;
                    el.alpha = 1;
                }

                if(el.name == 'obj14'){
                    el.scale.setTo(0.2);
                    el.x = gameWidth * 0.28;
                    el.y = gameHeight * 0.635;
                    el.angle = 315;
                    el.alpha = 1;
                }

                if(self.number.frame - 1 < 0){
                    levelsUnlocked = 2;
                    self.game.state.start('great');
                }
                self.number.frame -= 1;
                self.hiddenParticles.shift();
            })
            t4.start();
        });
        t0.start();
        
    },
    musicBtnPressed: function(){
        var self = window.GirlsGame.state.level1;
        if(self.musicBtnOn.visible){
            self.musicBtnOn.visible = false;
            self.musicBtnOff.visible = true;
            self.musicBtn = self.musicBtnOff;
            self.game.audioState = false;
            self.game.bckgAudio.stop();
        }
        else{
            self.musicBtnOn.visible = true;
            self.musicBtnOff.visible = false;
            self.musicBtn = self.musicBtnOn;
            self.game.audioState = true;
            self.game.bckgAudio.play();
        }
    },
    backPressed: function(){
        var self = this;
        if(self.game.audioState) self.game.btnClickAudio.play();
        this.game.state.start('levels');
    },
    hintBtnPressed: function(){
        var self = window.GirlsGame.state.level1;
        if(self.game.audioState) self.game.btnClickAudio.play();

        if(self.items.length > 0){
            var highlight = self.items[0];
            self.stars.x = highlight.x;
            self.stars.y = highlight.y;

            self.stars.alpha = 1;
            var t = self.game.add.tween(self.stars.scale);
            t.to({x: 0.075, y: 0.075}, 200, Phaser.Easing.Linear.None);
            t.onComplete.addOnce(function(){
                var t2 = self.game.add.tween(self.stars.scale);
                t2.to({x: 0.15, y: 0.15}, 500, Phaser.Easing.Linear.None);
                t2.start();

                var t3 = self.game.add.tween(self.stars);
                t3.to({alpha: 0}, 700, Phaser.Easing.Linear.None);
                t3.onComplete.addOnce(function(){
                    self.stars.scale.set(0.05);
                });
                t3.start();
            });
            t.start();
        }

    },
    create: function(){
        this.hiddenParticles = [];
        this.game.stage.backgroundColor = 0xb8ffe5;
        this.items = [];

        this.hidden_obj20 = this.game.add.button(0, 0, 'hidden_obj20', this.hiddenPressed);
        this.hidden_obj20.width = gameWidth * 0.07;
        this.hidden_obj20.height = gameHeight * 0.08;
        this.hidden_obj20.x = gameWidth * 0.6;
        this.hidden_obj20.y = gameHeight * 0.39;
        this.hidden_obj20.anchor.setTo(0.5);
        this.hidden_obj20.input.useHandCursor = false;

        var bckg1 = this.game.add.sprite(0, 0, 'level1_middle_layer');
        bckg1.width = gameWidth;
        bckg1.height = gameHeight;

        this.hidden_obj11 = this.game.add.button(0, 0, 'hidden_obj11', this.hiddenPressed);
        this.hidden_obj11.width = gameWidth * 0.06;
        this.hidden_obj11.height = gameHeight * 0.08;
        this.hidden_obj11.x = gameWidth * 0.89;
        this.hidden_obj11.y = gameHeight * 0.37;
        this.hidden_obj11.anchor.setTo(0.5);
        this.hidden_obj11.input.useHandCursor = false;

        this.hidden_obj8 = this.game.add.button(0, 0, 'hidden_obj8', this.hiddenPressed);
        this.hidden_obj8.width = gameWidth * 0.04;
        this.hidden_obj8.height = gameHeight * 0.1;
        this.hidden_obj8.x = gameWidth * 0.055;
        this.hidden_obj8.y = gameHeight * 0.7;
        this.hidden_obj8.anchor.setTo(0.5);
        this.hidden_obj8.input.useHandCursor = false;

        // pie
        this.pie = this.game.add.button(0, 0, 'pie', this.hiddenPressed);
        this.pie.name = 'pie';
        this.pie.width = gameWidth * 0.09;
        this.pie.height = gameHeight * 0.09;
        this.pie.x = gameWidth * 0.08;
        this.pie.y = gameHeight * 0.25;
        this.pie.anchor.setTo(0.5);
        this.pie.input.useHandCursor = false;

        this.hidden_obj2 = this.game.add.button(0, 0, 'hidden_obj2', this.hiddenPressed);
        this.hidden_obj2.name = 'obj2';
        this.hidden_obj2.width = gameWidth * 0.07;
        this.hidden_obj2.height = gameHeight * 0.09;
        this.hidden_obj2.x = gameWidth * 0.26;
        this.hidden_obj2.y = gameHeight * 0.42;
        this.hidden_obj2.anchor.setTo(0.5);
        this.hidden_obj2.input.useHandCursor = false;

        this.hidden_obj15 = this.game.add.button(0, 0, 'hidden_obj15', this.hiddenPressed);
        this.hidden_obj15.width = gameWidth * 0.05;
        this.hidden_obj15.height = gameHeight * 0.08;
        this.hidden_obj15.x = gameWidth * 0.28;
        this.hidden_obj15.y = gameHeight * 0.28;
        this.hidden_obj15.anchor.setTo(0.5);
        this.hidden_obj15.input.useHandCursor = false;

        this.hidden_obj13 = this.game.add.button(0, 0, 'hidden_obj13', this.hiddenPressed);
        this.hidden_obj13.width = gameWidth * 0.06;
        this.hidden_obj13.height = gameHeight * 0.1;
        this.hidden_obj13.x = gameWidth * 0.35;
        this.hidden_obj13.y = gameHeight * 0.07;
        this.hidden_obj13.anchor.setTo(0.5);
        this.hidden_obj13.input.useHandCursor = false;

        this.hidden_obj18 = this.game.add.button(0, 0, 'hidden_obj18', this.hiddenPressed);
        this.hidden_obj18.width = gameWidth * 0.07;
        this.hidden_obj18.height = gameHeight * 0.09;
        this.hidden_obj18.x = gameWidth * 0.41;
        this.hidden_obj18.y = gameHeight * 0.48;
        this.hidden_obj18.anchor.setTo(0.5);
        this.hidden_obj18.input.useHandCursor = false;

        this.hidden_obj7 = this.game.add.button(0, 0, 'hidden_obj7', this.hiddenPressed);
        this.hidden_obj7.name = 'obj7';
        this.hidden_obj7.width = gameWidth * 0.025;
        this.hidden_obj7.height = gameHeight * 0.06;
        this.hidden_obj7.x = gameWidth * 0.45;
        this.hidden_obj7.y = gameHeight * 0.39;
        this.hidden_obj7.anchor.setTo(0.5);
        this.hidden_obj7.input.useHandCursor = false;

        this.hidden_obj6 = this.game.add.button(0, 0, 'hidden_obj6', this.hiddenPressed);
        this.hidden_obj6.width = gameWidth * 0.08;
        this.hidden_obj6.height = gameHeight * 0.09;
        this.hidden_obj6.x = gameWidth * 0.74;
        this.hidden_obj6.y = gameHeight * 0.3;
        this.hidden_obj6.anchor.setTo(0.5);
        this.hidden_obj6.input.useHandCursor = false;

        this.hidden_obj5 = this.game.add.button(0, 0, 'hidden_obj5', this.hiddenPressed);
        this.hidden_obj5.width = gameWidth * 0.04;
        this.hidden_obj5.height = gameHeight * 0.08;
        this.hidden_obj5.x = gameWidth * 0.69;
        this.hidden_obj5.y = gameHeight * 0.4;
        this.hidden_obj5.anchor.setTo(0.5);
        this.hidden_obj5.input.useHandCursor = false;

        this.hidden_obj14 = this.game.add.button(0, 0, 'hidden_obj14', this.hiddenPressed);
        this.hidden_obj14.name = 'obj14';
        this.hidden_obj14.width = gameWidth * 0.06;
        this.hidden_obj14.height = gameHeight * 0.15;
        this.hidden_obj14.x = gameWidth * 0.87;
        this.hidden_obj14.y = gameHeight * 0.6;
        this.hidden_obj14.anchor.setTo(0.5);
        this.hidden_obj14.input.useHandCursor = false;

        this.hidden_obj16 = this.game.add.button(0, 0, 'hidden_obj16', this.hiddenPressed);
        this.hidden_obj16.width = gameWidth * 0.07;
        this.hidden_obj16.height = gameHeight * 0.09;
        this.hidden_obj16.x = gameWidth * 0.96;
        this.hidden_obj16.y = gameHeight * 0.655;
        this.hidden_obj16.anchor.setTo(0.5);
        this.hidden_obj16.input.useHandCursor = false;

        this.hidden_obj17 = this.game.add.button(0, 0, 'hidden_obj17', this.hiddenPressed);
        this.hidden_obj17.width = gameWidth * 0.1;
        this.hidden_obj17.height = gameHeight * 0.15;
        this.hidden_obj17.x = gameWidth * 0.88;
        this.hidden_obj17.y = gameHeight * 0.88;
        this.hidden_obj17.anchor.setTo(0.5);
        this.hidden_obj17.input.useHandCursor = false;

        this.hidden_obj19 = this.game.add.button(0, 0, 'hidden_obj19', this.hiddenPressed);
        this.hidden_obj19.width = gameWidth * 0.07;
        this.hidden_obj19.height = gameHeight * 0.18;
        this.hidden_obj19.x = gameWidth * 0.68;
        this.hidden_obj19.y = gameHeight * 0.9;
        this.hidden_obj19.anchor.setTo(0.5);
        this.hidden_obj19.input.useHandCursor = false;

        this.hidden_obj4 = this.game.add.button(0, 0, 'hidden_obj4', this.hiddenPressed);
        this.hidden_obj4.width = gameWidth * 0.05;
        this.hidden_obj4.height = gameHeight * 0.08;
        this.hidden_obj4.x = gameWidth * 0.57;
        this.hidden_obj4.y = gameHeight * 0.95;
        this.hidden_obj4.anchor.setTo(0.5);
        this.hidden_obj4.input.useHandCursor = false;

        this.hidden_obj3 = this.game.add.button(0, 0, 'hidden_obj3', this.hiddenPressed);
        this.hidden_obj3.name = 'obj3';
        this.hidden_obj3.width = gameWidth * 0.1;
        this.hidden_obj3.height = gameHeight * 0.16;
        this.hidden_obj3.x = gameWidth * 0.57;
        this.hidden_obj3.y = gameHeight * 0.82;
        this.hidden_obj3.anchor.setTo(0.5);
        this.hidden_obj3.input.useHandCursor = false;

        this.hidden_obj10 = this.game.add.button(0, 0, 'hidden_obj10', this.hiddenPressed);
        this.hidden_obj10.width = gameWidth * 0.05;
        this.hidden_obj10.height = gameHeight * 0.08;
        this.hidden_obj10.x = gameWidth * 0.61;
        this.hidden_obj10.y = gameHeight * 0.68;
        this.hidden_obj10.anchor.setTo(0.5);
        this.hidden_obj10.input.useHandCursor = false;

        this.hidden_obj9 = this.game.add.button(0, 0, 'hidden_obj9', this.hiddenPressed);
        this.hidden_obj9.width = gameWidth * 0.06;
        this.hidden_obj9.height = gameHeight * 0.1;
        this.hidden_obj9.x = gameWidth * 0.42;
        this.hidden_obj9.y = gameHeight * 0.62;
        this.hidden_obj9.anchor.setTo(0.5);
        this.hidden_obj9.input.useHandCursor = false;

        this.hidden_obj12 = this.game.add.button(0, 0, 'hidden_obj12', this.hiddenPressed);
        this.hidden_obj12.width = gameWidth * 0.09;
        this.hidden_obj12.height = gameHeight * 0.05;
        this.hidden_obj12.x = gameWidth * 0.19;
        this.hidden_obj12.y = gameHeight * 0.87;
        this.hidden_obj12.anchor.setTo(0.5);
        this.hidden_obj12.input.useHandCursor = false;   

        var bckg2 = this.game.add.sprite(0, 0, 'level1_upper_layer');
        bckg2.width = gameWidth;
        bckg2.height = gameHeight;

        // hint array
        this.items.push(this.hidden_obj13);
        this.items.push(this.pie);
        this.items.push(this.hidden_obj2);
        this.items.push(this.hidden_obj15);
        this.items.push(this.hidden_obj18);
        this.items.push(this.hidden_obj7);
        this.items.push(this.hidden_obj20);
        this.items.push(this.hidden_obj5);
        this.items.push(this.hidden_obj6);
        this.items.push(this.hidden_obj11);
        this.items.push(this.hidden_obj14);
        this.items.push(this.hidden_obj16);
        this.items.push(this.hidden_obj17);
        this.items.push(this.hidden_obj19);
        this.items.push(this.hidden_obj3);
        this.items.push(this.hidden_obj10);
        this.items.push(this.hidden_obj4);
        this.items.push(this.hidden_obj9);
        this.items.push(this.hidden_obj12);
        this.items.push(this.hidden_obj8);

        // logo
        this.logo = this.game.add.button(0, 0, 'rainbow_logo', this.btnPressed);
        this.logo.name = 'logo';
        this.logo.width = gameWidth * 0.3;
        this.logo.height = gameHeight * 0.175;
        this.logo.x = gameWidth * 0.15;
        this.logo.y = gameHeight * 0.1;
        this.logo.anchor.setTo(0.5);

        this.backBtnShadow = this.game.add.sprite(0, 0, 'back_btn');
        this.backBtnShadow.width = this.backBtnShadow.height = gameWidth * 0.15;
        this.backBtnShadow.x = gameWidth * 0.92;
        this.backBtnShadow.y = gameHeight * 0.87;
        this.backBtnShadow.anchor.set(0.5);
        this.backBtnShadow.scale.set(0.53);
        this.backBtnShadow.tint = 0x33FFFF;
        this.backBtnShadow.alpha = 0;

        var blurX = this.game.add.filter('BlurX');
        var blurY = this.game.add.filter('BlurY');
        this.backBtnShadow.filters = [blurX, blurY];

        var backBtn = this.game.add.button(0, 0, 'back_btn', this.backPressed);
        backBtn.width = backBtn.height = gameWidth * 0.15;
        backBtn.x = gameWidth * 0.92;
        backBtn.y = gameHeight * 0.87;
        backBtn.anchor.setTo(0.5);
        backBtn.scale.setTo(0.5);
        backBtn.inputEnabled = true;
        this.backBtn = backBtn;

        // hint stars
        this.stars = this.game.add.sprite(0, 0, 'stars', this.hiddenPressed);
        this.stars.width = gameWidth * 0.07;
        this.stars.height = gameHeight * 0.08;
        this.stars.anchor.setTo(0.5);
        this.stars.scale.setTo(0.05);
        this.stars.alpha = 0;
        this.backBtnShadow.filters = [blurX, blurY];

        this.plusBtnShadow = this.game.add.sprite(0, 0, 'plus_btn');
        this.plusBtnShadow.width = this.plusBtnShadow.height = gameWidth * 0.13;
        this.plusBtnShadow.x = gameWidth * 0.1;
        this.plusBtnShadow.y = gameHeight * 0.87;
        this.plusBtnShadow.anchor.set(0.5);
        this.plusBtnShadow.scale.set(0.53);
        this.plusBtnShadow.tint = 0x33FFFF;
        this.plusBtnShadow.alpha = 0;
        this.plusBtnShadow.filters = [blurX, blurY];

        // plus button
        this.plusBtn = this.game.add.button(0, 0, 'plus_btn', this.btnPressed);
        this.plusBtn.name = 'plus';
        this.plusBtn.width = this.plusBtn.height = gameWidth * 0.13;
        this.plusBtn.x = gameWidth * 0.1;
        this.plusBtn.y = gameHeight * 0.87;
        this.plusBtn.anchor.setTo(0.5);
        this.plusBtn.inputEnabled = true;
        this.plusBtn.input.pixelPerfectOver = true;

        // fb button
        this.fbBtn = this.game.add.button(0, 0, 'fb_btn', this.btnPressed);
        this.fbBtn.name = 'fb';
        this.fbBtn.width = this.fbBtn.height = gameWidth * 0.07;
        this.fbBtn.x = gameWidth * 0.84;
        this.fbBtn.y = gameHeight * 0.1;
        this.fbBtn.anchor.setTo(0.5);
        this.fbBtn.inputEnabled = true;

        // music button
        this.musicBtnOn = this.game.add.button(0, 0, 'music_on', this.musicBtnPressed);
        this.musicBtnOn.width = this.musicBtnOn.height = gameWidth * 0.09;
        this.musicBtnOn.x = gameWidth * 0.93;
        this.musicBtnOn.y = gameHeight * 0.1;
        this.musicBtnOn.anchor.setTo(0.5);
        this.musicBtnOn.inputEnabled = true;
        this.musicBtn = this.musicBtnOn;

        this.musicBtnOff = this.game.add.button(0, 0, 'music_off', this.musicBtnPressed);
        this.musicBtnOff.width = this.musicBtnOff.height = gameWidth * 0.09;
        this.musicBtnOff.x = gameWidth * 0.93;
        this.musicBtnOff.y = gameHeight * 0.1;
        this.musicBtnOff.anchor.setTo(0.5);
        this.musicBtnOff.inputEnabled = true;
        this.musicBtnOff.visible = false;

if(!this.game.audioState){
    this.musicBtnOn.visible = false;
    this.musicBtnOff.visible = true;
    this.nusicBtn = this.musicBtnOff;
}

        // hint button
        this.hintBtn = this.game.add.button(0, 0, 'hint_btn', this.hintBtnPressed);
        this.hintBtn.width = this.hintBtn.height = gameWidth * 0.09;
        this.hintBtn.x = gameWidth * 0.75;
        this.hintBtn.y = gameHeight * 0.1;
        this.hintBtn.anchor.setTo(0.5);
        this.hintBtn.inputEnabled = true;

        // items left
        this.itemsLeftBckg = this.game.add.sprite(0, 0, 'items_left');
        this.itemsLeftBckg.width = gameWidth * 0.18;
        this.itemsLeftBckg.height = gameWidth * 0.065;
        this.itemsLeftBckg.x = gameWidth * 0.6;
        this.itemsLeftBckg.y = gameHeight * 0.1;
        this.itemsLeftBckg.anchor.setTo(0.5);

        // number
        this.number = this.game.add.sprite(0, 0, 'numbers');
        this.number.anchor.setTo(0.5);
        this.number.scale.set(0.25);
        this.number.x = gameWidth * 0.55;
        this.number.y = gameHeight * 0.1;
        this.number.frame = 19;

        // eyes
        var eyes = this.game.add.sprite(0, 0, 'closed_eyes');
        eyes.width = gameWidth * 0.055;
        eyes.height = gameHeight * 0.06;
        eyes.x = gameWidth * 0.145;
        eyes.y = gameHeight * 0.36;
        eyes.visible = false;

        setInterval(function(){
            eyes.visible = true;
            setTimeout(function(){
                eyes.visible = false;
            }, 100);
            setTimeout(function(){
                eyes.visible = true;
            }, 200);
            setTimeout(function(){
                eyes.visible = false;
            }, 400);

        }, 2000);


        manager = this.game.plugins.add(Phaser.ParticleStorm);
        var spark = {
            image: 'star2',
            blendMode: 'HARD_LIGHT',
            lifespan: { min: 500, max: 1000 },
            scale: 0.1,
            vx: { value: { min: -1, max: 1 } },
            vy: { value: { min: -3, max: -2 }, delta: 0.01, control: [ { x: 0, y: 1 }, { x: 1, y: 0.5 } ] },
            alpha: { value: 1.0, control :[ { x: 0, y: 0 }, { x: 0.3, y: 1 }, { x: 1, y: 0 }] },
            rotation: { value: 0, delta: { min: -2.0, max: 2.0 } }
        };

        manager.addData('spark', spark);
        emitter = manager.createEmitter();
        emitter.addToWorld();
    },
    update: function(){
        for(var i in this.hiddenParticles){
            emitter.emit('spark', this.hiddenParticles[i].x, this.hiddenParticles[i].y, { total: 1 });
        }
        // buttons hover effect
        if(this.backBtn.input.pointerOver() && !this.backBtn.hovered){
            this.backBtn.hovered = true;
            this.btnHoverBubble(this.backBtn, this.backBtnShadow);
        }
        if(!this.backBtn.input.pointerOver() && this.backBtn.hovered){
            this.backBtn.hovered = false;
            this.backBtnShadow.alpha = 0;
        }
        if(!this.backBtn.hovered){
            this.backBtnShadow.alpha = 0;
        }

        if(this.plusBtn.input.pointerOver() && !this.plusBtn.hovered){
            this.plusBtn.hovered = true;
            this.btnHoverBubble(this.plusBtn, this.plusBtnShadow);
        }
        if(!this.plusBtn.input.pointerOver() && this.plusBtn.hovered){
            this.plusBtn.hovered = false;
            this.plusBtnShadow.alpha = 0;
        }
        if(!this.plusBtn.hovered){
            this.plusBtnShadow.alpha = 0;
        }

        if(this.musicBtn.input.pointerOver() && !this.musicBtn.hovered){
            this.musicBtn.hovered = true;
            this.btnHoverBubble(this.musicBtn);
        }
        if(!this.musicBtn.input.pointerOver() && this.musicBtn.hovered){
            this.musicBtn.hovered = false;
        }

        if(this.hintBtn.input.pointerOver() && !this.hintBtn.hovered){
            this.hintBtn.hovered = true;
            this.btnHoverBubble(this.hintBtn);
        }
        if(!this.hintBtn.input.pointerOver() && this.hintBtn.hovered){
            this.hintBtn.hovered = false;
        }
    }
}