"use strict";
window.GirlsGame.state.level2 = {
    game: window.GirlsGame.game,
    stockingsColors: [0xFFCC99, 0x996600, 0x99FFFF, 0xCC99FF, 0xffffff, 0xFF33FF, 0xFFCC00, 0x993300, 0xFFFF66, 0x99FF66],
    stockingsCurrent: -1,
    shoesColors: [0xFF33CC, 0x99FFFF, 0x999900, 0x9933CC, 0x999999, 0xFFFFFF, 0x663300, 0xCC6633, 0xFF6600, 0x330000],
    shoesCurrent: -1,
    dressCount: 10,
    dressCurrent: 0,
    hairCount: 9,
    hairCurrent: 0,
    bucketCount: 10,
    bucketCurrent: -1,
    hatBckgCurrent: -1,
    hatBckgCount: 8,
    hatBckgSprites: ['hat_bckg0', 'hat_bckg5', 'hat_bckg3', 'hat_bckg5', 'hat_bckg5', 'hat_bckg7', 'hat_bckg2', 'hat_bckg1', 'hat_bckg4', 'hat_bckg6'],
    hatCount: 10,
    hatCurrent: -1,
    hatSprites: ['hat0', 'hat5', 'hat3', 'hat9', 'hat8', 'hat7', 'hat2', 'hat1', 'hat4', 'hat6'],
    btnHoverBubble: function(el, shadow){
        var self = this;
        var stepTime = 75;
        var t = this.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.3}, stepTime, Phaser.Easing.Bounce.None);
        t.start();

        setTimeout(function(){
            var t2 = self.game.add.tween(el.scale);
            t2.to({x: 0.3, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
            t2.start();

            setTimeout(function(){
                var t3 = self.game.add.tween(el.scale);
                t3.to({x: 0.5, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
                t3.onComplete.addOnce(function(){
                    if(el.hovered && shadow){
                        var t4 = self.game.add.tween(shadow);
                        t4.to({alpha: 1}, stepTime * 3, Phaser.Easing.Linear.None);
                        t4.start();
                    }
                }, this);
                t3.start();

            }, stepTime);
        }, stepTime);

    },
    btnScaleHover: function(el, shadow){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.52, y: 0.52}, 50, Phaser.Easing.Linear.None);
        t.start();

        var t2 = self.game.add.tween(shadow.scale);
        t2.to({x: 0.57, y: 0.57}, 50, Phaser.Easing.Linear.None);
        t2.start();

        // var t3 = self.game.add.tween(shadow);
        // t3.to({alpha: 1}, 50, Phaser.Easing.Linear.None);
        // t3.start();
    },
    btnScaleOut: function(el, shadow){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.5}, 50, Phaser.Easing.Linear.None);
        t.start();

        var t2 = self.game.add.tween(shadow.scale);
        t2.to({x: 0.5, y: 0.5}, 50, Phaser.Easing.Linear.None);
        t2.start();

        // var t3 = self.game.add.tween(shadow);
        // t3.to({alpha: 0}, 50, Phaser.Easing.Linear.None);
        // t3.start();
    },
    btnPressed: function(el){
        var uri = null;
        if(el.name == 'fb'){
            uri = fbUri;
        }
        if(el.name == 'logo'){
            uri = logoUri
        }
        if(el.name == 'plus'){
            uri = plusUri
        }

        var win = window.open(uri, '_blank');
        win.focus();
    },
    musicBtnPressed: function(){
        var self = window.GirlsGame.state.level2;
        if(self.musicBtnOn.visible){
            self.musicBtnOn.visible = false;
            self.musicBtnOff.visible = true;
            self.musicBtn = self.musicBtnOff;
            self.game.audioState = false;
            self.game.bckgAudio.stop();
        }
        else{
            self.musicBtnOn.visible = true;
            self.musicBtnOff.visible = false;
            self.musicBtn = self.musicBtnOn;
            self.game.audioState = true;
            self.game.bckgAudio.play();
        }
    },
    playPressed: function(){
        var self = this;
        if(self.game.audioState) self.game.btnClickAudio.play();
        var t = this.game.add.tween(this.game.world);
        t.to({alpha: 0}, 400, Phaser.Easing.Linear.None);
        t.start();

        setTimeout(function(){
            self.game.state.start('level2');
            self.game.world.alpha = 1;
        }, 350);
    },
    backPressed: function(){
        var self = this;
        if(self.game.audioState) self.game.btnClickAudio.play();
        this.game.state.start('levels');
    },
    updateWear: function(el){
        var self = window.GirlsGame.state.level2;
        if(self.game.audioState) self.game.wearEffectAudio.play();
        var highlight = null;

        // hide wear
        if(el.name.indexOf('x') > -1){
            var wear = el.name.slice(1);
            if(wear == 'dress'){
                for(var i = 0; i < self.dressCount; i++){
                    self['dress' + i].visible = false;
                }
            }
            else if(wear == 'hair'){
                for(var i = 0; i < self.hairCount; i++){
                    self['hair' + i].visible = false;
                }
            }
            else if(wear == 'bucket'){
                for(var i = 0; i < self.bucketCount; i++){
                    self['bucket' + i].visible = false;
                }
            }
            else if(wear == 'hat'){
                for(var i = 0; i < self.hatBckgCount; i++){
                    self['hat_bckg' + i].visible = false;
                }

                for(var i = 0; i < self.hatCount; i++){
                    self['hat' + i].visible = false;
                }
                self.hatBckgCurrent = -1;
            }
            else{
                self[wear].visible = false;
            }

            self[wear + 'Current'] = -1;
            return;
        }

        if(el.name == 'stockings'){
            self.stockingsCurrent++;
            if(self.stockingsCurrent > self.stockingsColors.length - 1){
                self.stockingsCurrent = 0;
            }

            self.stockings.tint = self.stockingsColors[self.stockingsCurrent];
            highlight = self.stockings;
            self.stockings.visible = true;
        }

        if(el.name == 'shoes'){
            self.shoesCurrent++;
            if(self.shoesCurrent > self.shoesColors.length - 1){
                self.shoesCurrent = 0;
            }

            self.shoes.tint = self.shoesColors[self.shoesCurrent];
            self.shoes.visible = true;
            highlight = self.shoes;
        }

        if(el.name == 'dress'){
            self.dressCurrent++;
            if(self.dressCurrent > self.dressCount - 1){
                self.dressCurrent = 0;
            }

            for(var i = 0; i < self.dressCount; i++){
                self['dress' + i].visible = false;
            }

            self['dress' + self.dressCurrent].visible = true;
            highlight = self['dress' + self.dressCurrent];
        }

        if(el.name == 'hair'){
            self.hairCurrent++;
            if(self.hairCurrent > self.hairCount - 1){
                self.hairCurrent = 0;
            }

            for(var i = 0; i < self.hairCount; i++){
                self['hair' + i].visible = false;
            }

            self['hair' + self.hairCurrent].visible = true;
            highlight = self['hair' + self.hairCurrent];
        }

        if(el.name == 'bucket'){
            self.bucketCurrent++;
            if(self.bucketCurrent > self.bucketCount - 1){
                self.bucketCurrent = 0;
            }

            for(var i = 0; i < self.bucketCount; i++){
                self['bucket' + i].visible = false;
            }

            self['bucket' + self.bucketCurrent].visible = true;
            highlight = self['bucket' + self.bucketCurrent];
        }

        if(el.name == 'hat'){
            self.hatBckgCurrent++;
            self.hatCurrent++;
            if(self.hatBckgCurrent > self.hatBckgSprites.length - 1){
                self.hatBckgCurrent = 0;
            }

            if(self.hatCurrent > self.hatSprites.length - 1){
                self.hatCurrent = 0;
            }

            for(var i = 0; i < self.hatBckgCount; i++){
                self['hat_bckg' + i].visible = false;
            }

            for(var i = 0; i < self.hatCount; i++){
                self['hat' + i].visible = false;
            }

            self[self.hatBckgSprites[self.hatBckgCurrent]].visible = true;
            self[self.hatSprites[self.hatCurrent]].visible = true;
            highlight = self[self.hatSprites[self.hatCurrent]];
        }


        self.doneBtn.visible = true;
        self.doneBtnShadow.visible = true;

        self.stars.x = highlight.x;
        self.stars.y = highlight.y;

        self.stars.alpha = 1;
        var t = self.game.add.tween(self.stars.scale);
        t.to({x: 0.35, y: 0.35}, 500, Phaser.Easing.Linear.None);
        t.start();

        var t2 = self.game.add.tween(self.stars);
        t2.to({angle: 1800}, 500, Phaser.Easing.Linear.None);
        t2.start();

        var t3 = self.game.add.tween(self.stars);
        t3.to({alpha: 0}, 700, Phaser.Easing.Linear.None);
        t3.onComplete.addOnce(function(){
            self.stars.scale.set(0.05);
            self.stars.angle = 0;
        });
        t3.start();
    },
    donePressed: function(){
        var self = this;
        if(self.game.audioState) self.game.btnClickAudio.play();
        this.game.state.start('intro2_1');
        levelsUnlocked = 3;
    },
    create: function(){
        // background
        var bckg = this.game.add.sprite(0, 0, 'level2_bckg');
        bckg.width = gameWidth;
        bckg.height = gameHeight;

        var blurX = this.game.add.filter('BlurX');
        var blurY = this.game.add.filter('BlurY');

        // plus button
        this.plusBtn = this.game.add.button(0, 0, 'plus_btn', this.btnPressed);
        this.plusBtn.name = 'plus';
        this.plusBtn.width = this.plusBtn.height = gameWidth * 0.13;
        this.plusBtn.x = gameWidth * 0.93;
        this.plusBtn.y = gameHeight * 0.89;
        this.plusBtn.anchor.setTo(0.5);
        this.plusBtn.inputEnabled = true;
        this.plusBtn.input.pixelPerfectOver = true;

        // fb button
        this.fbBtn = this.game.add.button(0, 0, 'fb_btn', this.btnPressed);
        this.fbBtn.name = 'fb';
        this.fbBtn.width = this.fbBtn.height = gameWidth * 0.07;
        this.fbBtn.x = gameWidth * 0.84;
        this.fbBtn.y = gameHeight * 0.1;
        this.fbBtn.anchor.setTo(0.5);
        this.fbBtn.inputEnabled = true;

        // music button
        this.musicBtnOn = this.game.add.button(0, 0, 'music_on', this.musicBtnPressed);
        this.musicBtnOn.width = this.musicBtnOn.height = gameWidth * 0.09;
        this.musicBtnOn.x = gameWidth * 0.93;
        this.musicBtnOn.y = gameHeight * 0.1;
        this.musicBtnOn.anchor.setTo(0.5);
        this.musicBtnOn.inputEnabled = true;
        this.musicBtn = this.musicBtnOn;

        this.musicBtnOff = this.game.add.button(0, 0, 'music_off', this.musicBtnPressed);
        this.musicBtnOff.width = this.musicBtnOff.height = gameWidth * 0.09;
        this.musicBtnOff.x = gameWidth * 0.93;
        this.musicBtnOff.y = gameHeight * 0.1;
        this.musicBtnOff.anchor.setTo(0.5);
        this.musicBtnOff.visible = false;

if(!this.game.audioState){
    this.musicBtnOn.visible = false;
    this.musicBtnOff.visible = true;
    this.nusicBtn = this.musicBtnOff;
}

        // back button
        this.backBtn = this.game.add.button(0, 0, 'back_play_btn', this.backPressed);
        this.backBtn.width = this.backBtn.height = gameWidth * 0.09;
        this.backBtn.x = gameWidth * 0.95;
        this.backBtn.y = gameHeight * 0.28;
        this.backBtn.anchor.setTo(0.5);
        this.backBtn.inputEnabled = true;

        // logo
        this.logo = this.game.add.button(0, 0, 'rainbow_logo', this.btnPressed);
        this.logo.name = 'logo';
        this.logo.width = gameWidth * 0.3;
        this.logo.height = gameHeight * 0.175;
        this.logo.x = gameWidth * 0.15;
        this.logo.y = gameHeight * 0.1;
        this.logo.anchor.setTo(0.5);
        this.game.logo = this.logo;

        // buttons
        this.bucketBtnShadow = this.game.add.sprite(0, 0, 'bucket_btn');
        this.bucketBtnShadow.width = gameWidth * 0.07;
        this.bucketBtnShadow.height = gameHeight * 0.12;
        this.bucketBtnShadow.x = gameWidth * 0.82;
        this.bucketBtnShadow.y = gameHeight * 0.93;
        this.bucketBtnShadow.tint = 0x33FFFF;
        this.bucketBtnShadow.anchor.setTo(0.5);
        this.bucketBtnShadow.filters = [blurX, blurY];

        this.bucketBtn = this.game.add.button(0, 0, 'bucket_btn', this.updateWear);
        this.bucketBtn.name = 'bucket';
        this.bucketBtn.width = gameWidth * 0.07;
        this.bucketBtn.height = gameHeight * 0.12;
        this.bucketBtn.x = gameWidth * 0.82;
        this.bucketBtn.y = gameHeight * 0.93;
        this.bucketBtn.anchor.setTo(0.5);

        this.xbucketBtnShadow = this.game.add.sprite(0, 0, 'x_btn');
        this.xbucketBtnShadow.width = gameWidth * 0.04;
        this.xbucketBtnShadow.height = gameHeight * 0.07;
        this.xbucketBtnShadow.x = gameWidth * 0.85;
        this.xbucketBtnShadow.y = gameHeight * 0.96;
        this.xbucketBtnShadow.tint = 0x33FFFF;
        this.xbucketBtnShadow.anchor.setTo(0.5);
        this.xbucketBtnShadow.filters = [blurX, blurY];

        this.xbucketBtn = this.game.add.button(0, 0, 'x_btn', this.updateWear);
        this.xbucketBtn.name = 'xbucket';
        this.xbucketBtn.width = gameWidth * 0.04;
        this.xbucketBtn.height = gameHeight * 0.07;
        this.xbucketBtn.x = gameWidth * 0.85;
        this.xbucketBtn.y = gameHeight * 0.96;
        this.xbucketBtn.anchor.setTo(0.5);

        this.shoesBtnShadow = this.game.add.sprite(0, 0, 'shoes_btn');
        this.shoesBtnShadow.width = gameWidth * 0.07;
        this.shoesBtnShadow.height = gameHeight * 0.12;
        this.shoesBtnShadow.x = gameWidth * 0.73;
        this.shoesBtnShadow.y = gameHeight * 0.93;
        this.shoesBtnShadow.tint = 0x33FFFF;
        this.shoesBtnShadow.anchor.setTo(0.5);
        this.shoesBtnShadow.filters = [blurX, blurY];

        this.shoesBtn = this.game.add.button(0, 0, 'shoes_btn', this.updateWear);
        this.shoesBtn.name = 'shoes';
        this.shoesBtn.width = gameWidth * 0.07;
        this.shoesBtn.height = gameHeight * 0.12;
        this.shoesBtn.x = gameWidth * 0.73;
        this.shoesBtn.y = gameHeight * 0.93;
        this.shoesBtn.anchor.setTo(0.5);

        this.xshoesBtnShadow = this.game.add.sprite(0, 0, 'x_btn');
        this.xshoesBtnShadow.width = gameWidth * 0.04;
        this.xshoesBtnShadow.height = gameHeight * 0.07;
        this.xshoesBtnShadow.x = gameWidth * 0.76;
        this.xshoesBtnShadow.y = gameHeight * 0.96;
        this.xshoesBtnShadow.tint = 0x33FFFF;
        this.xshoesBtnShadow.anchor.setTo(0.5);
        this.xshoesBtnShadow.filters = [blurX, blurY];

        this.xshoesBtn = this.game.add.button(0, 0, 'x_btn', this.updateWear);
        this.xshoesBtn.name = 'xshoes';
        this.xshoesBtn.width = gameWidth * 0.04;
        this.xshoesBtn.height = gameHeight * 0.07;
        this.xshoesBtn.x = gameWidth * 0.76;
        this.xshoesBtn.y = gameHeight * 0.96;
        this.xshoesBtn.anchor.setTo(0.5);

        this.stockingsBtnShadow = this.game.add.sprite(0, 0, 'stockings_btn');
        this.stockingsBtnShadow.width = gameWidth * 0.07;
        this.stockingsBtnShadow.height = gameHeight * 0.12;
        this.stockingsBtnShadow.x = gameWidth * 0.47;
        this.stockingsBtnShadow.y = gameHeight * 0.93;
        this.stockingsBtnShadow.tint = 0x33FFFF;
        this.stockingsBtnShadow.anchor.setTo(0.5);
        this.stockingsBtnShadow.filters = [blurX, blurY];

        this.stockingsBtn = this.game.add.button(0, 0, 'stockings_btn', this.updateWear);
        this.stockingsBtn.name = 'stockings';
        this.stockingsBtn.width = gameWidth * 0.07;
        this.stockingsBtn.height = gameHeight * 0.12;
        this.stockingsBtn.x = gameWidth * 0.47;
        this.stockingsBtn.y = gameHeight * 0.93;
        this.stockingsBtn.anchor.setTo(0.5);

        this.xstockingsBtnShadow = this.game.add.sprite(0, 0, 'x_btn');
        this.xstockingsBtnShadow.width = gameWidth * 0.04;
        this.xstockingsBtnShadow.height = gameHeight * 0.07;
        this.xstockingsBtnShadow.x = gameWidth * 0.44;
        this.xstockingsBtnShadow.y = gameHeight * 0.96;
        this.xstockingsBtnShadow.tint = 0x33FFFF;
        this.xstockingsBtnShadow.anchor.setTo(0.5);
        this.xstockingsBtnShadow.filters = [blurX, blurY];

        this.xstockingsBtn = this.game.add.button(0, 0, 'x_btn', this.updateWear);
        this.xstockingsBtn.name = 'xstockings';
        this.xstockingsBtn.width = gameWidth * 0.04;
        this.xstockingsBtn.height = gameHeight * 0.07;
        this.xstockingsBtn.x = gameWidth * 0.44;
        this.xstockingsBtn.y = gameHeight * 0.96;
        this.xstockingsBtn.anchor.setTo(0.5);

        this.hatBtnShadow = this.game.add.sprite(0, 0, 'hat_btn');
        this.hatBtnShadow.width = gameWidth * 0.07;
        this.hatBtnShadow.height = gameHeight * 0.12;
        this.hatBtnShadow.x = gameWidth * 0.381;
        this.hatBtnShadow.y = gameHeight * 0.93;
        this.hatBtnShadow.tint = 0x33FFFF;
        this.hatBtnShadow.anchor.setTo(0.5);
        this.hatBtnShadow.filters = [blurX, blurY];

        this.hatBtn = this.game.add.button(0, 0, 'hat_btn', this.updateWear);
        this.hatBtn.name = 'hat';
        this.hatBtn.width = gameWidth * 0.07;
        this.hatBtn.height = gameHeight * 0.12;
        this.hatBtn.x = gameWidth * 0.38;
        this.hatBtn.y = gameHeight * 0.93;
        this.hatBtn.anchor.setTo(0.5);

        this.xhatBtnShadow = this.game.add.sprite(0, 0, 'x_btn');
        this.xhatBtnShadow.width = gameWidth * 0.04;
        this.xhatBtnShadow.height = gameHeight * 0.07;
        this.xhatBtnShadow.x = gameWidth * 0.35;
        this.xhatBtnShadow.y = gameHeight * 0.96;
        this.xhatBtnShadow.tint = 0x33FFFF;
        this.xhatBtnShadow.anchor.setTo(0.5);
        this.xhatBtnShadow.filters = [blurX, blurY];

        this.xhatBtn = this.game.add.button(0, 0, 'x_btn', this.updateWear);
        this.xhatBtn.name = 'xhat';
        this.xhatBtn.width = gameWidth * 0.04;
        this.xhatBtn.height = gameHeight * 0.07;
        this.xhatBtn.x = gameWidth * 0.35;
        this.xhatBtn.y = gameHeight * 0.96;
        this.xhatBtn.anchor.setTo(0.5);

        this.dressBtnShadow = this.game.add.sprite(0, 0, 'dress_btn');
        this.dressBtnShadow.width = gameWidth * 0.07;
        this.dressBtnShadow.height = gameHeight * 0.12;
        this.dressBtnShadow.x = gameWidth * 0.291;
        this.dressBtnShadow.y = gameHeight * 0.93;
        this.dressBtnShadow.tint = 0x33FFFF;
        this.dressBtnShadow.anchor.setTo(0.5);
        this.dressBtnShadow.filters = [blurX, blurY];

        this.dressBtn = this.game.add.button(0, 0, 'dress_btn', this.updateWear);
        this.dressBtn.name = 'dress';
        this.dressBtn.width = gameWidth * 0.07;
        this.dressBtn.height = gameHeight * 0.12;
        this.dressBtn.x = gameWidth * 0.29;
        this.dressBtn.y = gameHeight * 0.93;
        this.dressBtn.anchor.setTo(0.5);

        this.xdressBtnShadow = this.game.add.sprite(0, 0, 'x_btn');
        this.xdressBtnShadow.width = gameWidth * 0.04;
        this.xdressBtnShadow.height = gameHeight * 0.07;
        this.xdressBtnShadow.x = gameWidth * 0.26;
        this.xdressBtnShadow.y = gameHeight * 0.96;
        this.xdressBtnShadow.tint = 0x33FFFF;
        this.xdressBtnShadow.anchor.setTo(0.5);
        this.xdressBtnShadow.filters = [blurX, blurY];

        this.xdressBtn = this.game.add.button(0, 0, 'x_btn', this.updateWear);
        this.xdressBtn.name = 'xdress';
        this.xdressBtn.width = gameWidth * 0.04;
        this.xdressBtn.height = gameHeight * 0.07;
        this.xdressBtn.x = gameWidth * 0.26;
        this.xdressBtn.y = gameHeight * 0.96;
        this.xdressBtn.anchor.setTo(0.5);

        this.hairBtnShadow = this.game.add.sprite(0, 0, 'hair_btn');
        this.hairBtnShadow.width = gameWidth * 0.07;
        this.hairBtnShadow.height = gameHeight * 0.12;
        this.hairBtnShadow.x = gameWidth * 0.2;
        this.hairBtnShadow.y = gameHeight * 0.93;
        this.hairBtnShadow.tint = 0x33FFFF;
        this.hairBtnShadow.anchor.setTo(0.5);
        this.hairBtnShadow.filters = [blurX, blurY];

        this.hairBtn = this.game.add.button(0, 0, 'hair_btn', this.updateWear);
        this.hairBtn.name = 'hair';
        this.hairBtn.width = gameWidth * 0.07;
        this.hairBtn.height = gameHeight * 0.12;
        this.hairBtn.x = gameWidth * 0.2;
        this.hairBtn.y = gameHeight * 0.93;
        this.hairBtn.anchor.setTo(0.5);

        this.xhairBtnShadow = this.game.add.sprite(0, 0, 'x_btn');
        this.xhairBtnShadow.width = gameWidth * 0.04;
        this.xhairBtnShadow.height = gameHeight * 0.07;
        this.xhairBtnShadow.x = gameWidth * 0.17;
        this.xhairBtnShadow.y = gameHeight * 0.96;
        this.xhairBtnShadow.tint = 0x33FFFF;
        this.xhairBtnShadow.anchor.setTo(0.5);
        this.xhairBtnShadow.filters = [blurX, blurY];

        this.xhairBtn = this.game.add.button(0, 0, 'x_btn', this.updateWear);
        this.xhairBtn.name = 'xhair';
        this.xhairBtn.width = gameWidth * 0.04;
        this.xhairBtn.height = gameHeight * 0.07;
        this.xhairBtn.x = gameWidth * 0.17;
        this.xhairBtn.y = gameHeight * 0.96;
        this.xhairBtn.anchor.setTo(0.5);

        this.wearButtons = ['xbucketBtn', 'bucketBtn', 'xshoesBtn', 'shoesBtn', 'xstockingsBtn', 'stockingsBtn', 'xhatBtn', 'hatBtn', 'xdressBtn', 'dressBtn', 'xhairBtn', 'hairBtn'];

        // eyes
        var eyes = this.game.add.sprite(0, 0, 'closed_eyes');
        // eyes.width = gameWidth * 0.025;
        // eyes.height = gameHeight * 0.06;
        eyes.x = gameWidth * 0.651;
        eyes.y = gameHeight * 0.16;
        eyes.visible = false;
        eyes.scale.setTo(-0.28, 0.28);
        eyes.angle = -17;

        setInterval(function(){
            eyes.visible = true;
            setTimeout(function(){
                eyes.visible = false;
            }, 100);
            setTimeout(function(){
                eyes.visible = true;
            }, 200);
            setTimeout(function(){
                eyes.visible = false;
            }, 400);

        }, 2000);

        this.stockings = this.game.add.sprite(0, 0, 'stockings');
        this.stockings.width = gameWidth * 0.07;
        this.stockings.height = gameHeight * 0.12;
        this.stockings.x = gameWidth * 0.5965;
        this.stockings.y = gameHeight * 0.825;
        this.stockings.anchor.setTo(0.5);
        this.stockings.scale.setTo(0.54, 0.55);
        this.stockings.visible = false;

        this.shoes = this.game.add.sprite(0, 0, 'shoes');
        this.shoes.width = gameWidth * 0.07;
        this.shoes.height = gameHeight * 0.12;
        this.shoes.x = gameWidth * 0.5965;
        this.shoes.y = gameHeight * 0.86;
        this.shoes.anchor.setTo(0.5);
        this.shoes.scale.setTo(0.54, 0.55);
        this.shoes.visible = false;

        this.hat_bckg0 = this.game.add.sprite(0, 0, 'hat_bckg0');
        this.hat_bckg0.x = gameWidth * 0.6085;
        this.hat_bckg0.y = gameHeight * 0.32;
        this.hat_bckg0.anchor.setTo(0.5);
        this.hat_bckg0.scale.set(0.5);
        this.hat_bckg0.visible = false;

        this.hat_bckg1 = this.game.add.sprite(0, 0, 'hat_bckg1');
        this.hat_bckg1.x = gameWidth * 0.6085;
        this.hat_bckg1.y = gameHeight * 0.32;
        this.hat_bckg1.anchor.setTo(0.5);
        this.hat_bckg1.scale.set(0.5);
        this.hat_bckg1.visible = false;

        this.hat_bckg2 = this.game.add.sprite(0, 0, 'hat_bckg2');
        this.hat_bckg2.x = gameWidth * 0.6085;
        this.hat_bckg2.y = gameHeight * 0.32;
        this.hat_bckg2.anchor.setTo(0.5);
        this.hat_bckg2.scale.set(0.5);
        this.hat_bckg2.visible = false;

        this.hat_bckg3 = this.game.add.sprite(0, 0, 'hat_bckg3');
        this.hat_bckg3.x = gameWidth * 0.6085;
        this.hat_bckg3.y = gameHeight * 0.32;
        this.hat_bckg3.anchor.setTo(0.5);
        this.hat_bckg3.scale.set(0.5);
        this.hat_bckg3.visible = false;

        this.hat_bckg4 = this.game.add.sprite(0, 0, 'hat_bckg4');
        this.hat_bckg4.x = gameWidth * 0.6085;
        this.hat_bckg4.y = gameHeight * 0.32;
        this.hat_bckg4.anchor.setTo(0.5);
        this.hat_bckg4.scale.set(0.5);
        this.hat_bckg4.visible = false;

        this.hat_bckg5 = this.game.add.sprite(0, 0, 'hat_bckg5');
        this.hat_bckg5.x = gameWidth * 0.654;
        this.hat_bckg5.y = gameHeight * 0.45;
        this.hat_bckg5.anchor.setTo(0.5);
        this.hat_bckg5.scale.set(0.5);
        this.hat_bckg5.visible = false;

        this.hat_bckg6 = this.game.add.sprite(0, 0, 'hat_bckg6');
        this.hat_bckg6.x = gameWidth * 0.665;
        this.hat_bckg6.y = gameHeight * 0.3;
        this.hat_bckg6.anchor.setTo(0.5);
        this.hat_bckg6.scale.set(0.5);
        this.hat_bckg6.visible = false;

        this.hat_bckg7 = this.game.add.sprite(0, 0, 'hat_bckg7');
        this.hat_bckg7.x = gameWidth * 0.654;
        this.hat_bckg7.y = gameHeight * 0.45;
        this.hat_bckg7.anchor.setTo(0.5);
        this.hat_bckg7.scale.set(0.5);
        this.hat_bckg7.visible = false;

        this.dress0 = this.game.add.sprite(0, 0, 'dress0');
        this.dress0.x = gameWidth * 0.587;
        this.dress0.y = gameHeight * 0.535;
        this.dress0.anchor.setTo(0.5);
        this.dress0.scale.set(0.5);
        this.dress0.visible = true;

        this.dress1 = this.game.add.sprite(0, 0, 'dress1');
        this.dress1.x = gameWidth * 0.587;
        this.dress1.y = gameHeight * 0.535;
        this.dress1.anchor.setTo(0.5);
        this.dress1.scale.set(0.5);
        this.dress1.visible = false;

        this.dress2 = this.game.add.sprite(0, 0, 'dress2');
        this.dress2.x = gameWidth * 0.595;
        this.dress2.y = gameHeight * 0.54;
        this.dress2.anchor.setTo(0.5);
        this.dress2.scale.set(0.5);
        this.dress2.visible = false;

        this.dress3 = this.game.add.sprite(0, 0, 'dress3');
        this.dress3.x = gameWidth * 0.595;
        this.dress3.y = gameHeight * 0.54;
        this.dress3.anchor.setTo(0.5);
        this.dress3.scale.set(0.5);
        this.dress3.visible = false;

        this.dress4 = this.game.add.sprite(0, 0, 'dress4');
        this.dress4.x = gameWidth * 0.595;
        this.dress4.y = gameHeight * 0.54;
        this.dress4.anchor.setTo(0.5);
        this.dress4.scale.set(0.5);
        this.dress4.visible = false;

        this.dress5 = this.game.add.sprite(0, 0, 'dress5');
        this.dress5.x = gameWidth * 0.598;
        this.dress5.y = gameHeight * 0.525;
        this.dress5.anchor.setTo(0.5);
        this.dress5.scale.set(0.5);
        this.dress5.visible = false;

        this.dress6 = this.game.add.sprite(0, 0, 'dress6');
        this.dress6.x = gameWidth * 0.6;
        this.dress6.y = gameHeight * 0.535;
        this.dress6.anchor.setTo(0.5);
        this.dress6.scale.set(0.5);
        this.dress6.visible = false;

        this.dress7 = this.game.add.sprite(0, 0, 'dress7');
        this.dress7.x = gameWidth * 0.598;
        this.dress7.y = gameHeight * 0.525;
        this.dress7.anchor.setTo(0.5);
        this.dress7.scale.set(0.5);
        this.dress7.visible = false;

        this.dress8 = this.game.add.sprite(0, 0, 'dress8');
        this.dress8.x = gameWidth * 0.597;
        this.dress8.y = gameHeight * 0.52;
        this.dress8.anchor.setTo(0.5);
        this.dress8.scale.set(0.5);
        this.dress8.visible = false;

        this.dress9 = this.game.add.sprite(0, 0, 'dress9');
        this.dress9.x = gameWidth * 0.598;
        this.dress9.y = gameHeight * 0.515;
        this.dress9.anchor.setTo(0.5);
        this.dress9.scale.set(0.5);
        this.dress9.visible = false;

        this.dressUpHand = this.game.add.sprite(0, 0, 'dress-up_hand');
        this.dressUpHand.scale.set(0.55);
        this.dressUpHand.x = gameWidth * 0.533;
        this.dressUpHand.y = gameHeight * 0.53;
        this.dressUpHand.anchor.setTo(0.5);

        this.hair0 = this.game.add.sprite(0, 0, 'hair0');
        this.hair0.x = gameWidth * 0.628;
        this.hair0.y = gameHeight * 0.234;
        this.hair0.anchor.setTo(0.5);
        this.hair0.scale.set(0.5);
        this.hair0.visible = true;

        this.hair1 = this.game.add.sprite(0, 0, 'hair1');
        this.hair1.x = gameWidth * 0.628;
        this.hair1.y = gameHeight * 0.21;
        this.hair1.anchor.setTo(0.5);
        this.hair1.scale.set(0.478);
        this.hair1.visible = false;

        this.hair2 = this.game.add.sprite(0, 0, 'hair2');
        this.hair2.x = gameWidth * 0.625;
        this.hair2.y = gameHeight * 0.372;
        this.hair2.anchor.setTo(0.5);
        this.hair2.scale.set(0.5);
        this.hair2.visible = false;

        this.hair3 = this.game.add.sprite(0, 0, 'hair3');
        this.hair3.x = gameWidth * 0.629;
        this.hair3.y = gameHeight * 0.23;
        this.hair3.anchor.setTo(0.5);
        this.hair3.scale.set(0.5);
        this.hair3.visible = false;

        this.hair4 = this.game.add.sprite(0, 0, 'hair4');
        this.hair4.x = gameWidth * 0.638;
        this.hair4.y = gameHeight * 0.23;
        this.hair4.anchor.setTo(0.5);
        this.hair4.scale.set(0.5);
        this.hair4.visible = false;

        this.hair5 = this.game.add.sprite(0, 0, 'hair5');
        this.hair5.x = gameWidth * 0.634;
        this.hair5.y = gameHeight * 0.2115;
        this.hair5.anchor.setTo(0.5);
        this.hair5.scale.set(0.5);
        this.hair5.visible = false;

        this.hair6 = this.game.add.sprite(0, 0, 'hair6');
        this.hair6.x = gameWidth * 0.618;
        this.hair6.y = gameHeight * 0.3;
        this.hair6.anchor.setTo(0.5);
        this.hair6.scale.set(0.5);
        this.hair6.visible = false;

        this.hair7 = this.game.add.sprite(0, 0, 'hair7');
        this.hair7.x = gameWidth * 0.627;
        this.hair7.y = gameHeight * 0.215;
        this.hair7.anchor.setTo(0.5);
        this.hair7.scale.set(0.5);
        this.hair7.visible = false;

        this.hair8 = this.game.add.sprite(0, 0, 'hair8');
        this.hair8.x = gameWidth * 0.61;
        this.hair8.y = gameHeight * 0.3;
        this.hair8.anchor.setTo(0.5);
        this.hair8.scale.set(0.5);
        this.hair8.visible = false;

        this.hat0 = this.game.add.sprite(0, 0, 'hat0');
        this.hat0.x = gameWidth * 0.696;
        this.hat0.y = gameHeight * 0.165;
        this.hat0.anchor.setTo(0.5);
        this.hat0.scale.set(0.5);
        this.hat0.visible = false;

        this.hat1 = this.game.add.sprite(0, 0, 'hat1');
        this.hat1.x = gameWidth * 0.696;
        this.hat1.y = gameHeight * 0.165;
        this.hat1.anchor.setTo(0.5);
        this.hat1.scale.set(0.5);
        this.hat1.visible = false;

        this.hat2 = this.game.add.sprite(0, 0, 'hat2');
        this.hat2.x = gameWidth * 0.696;
        this.hat2.y = gameHeight * 0.165;
        this.hat2.anchor.setTo(0.5);
        this.hat2.scale.set(0.5);
        this.hat2.visible = false;

        this.hat3 = this.game.add.sprite(0, 0, 'hat3');
        this.hat3.x = gameWidth * 0.696;
        this.hat3.y = gameHeight * 0.165;
        this.hat3.anchor.setTo(0.5);
        this.hat3.scale.set(0.5);
        this.hat3.visible = false;

        this.hat4 = this.game.add.sprite(0, 0, 'hat4');
        this.hat4.x = gameWidth * 0.696;
        this.hat4.y = gameHeight * 0.165;
        this.hat4.anchor.setTo(0.5);
        this.hat4.scale.set(0.5);
        this.hat4.visible = false;

        this.hat5 = this.game.add.sprite(0, 0, 'hat5');
        this.hat5.x = gameWidth * 0.675;
        this.hat5.y = gameHeight * 0.45;
        this.hat5.anchor.setTo(0.5);
        this.hat5.scale.set(0.5);
        this.hat5.visible = false;

        this.hat6 = this.game.add.sprite(0, 0, 'hat6');
        this.hat6.x = gameWidth * 0.665;
        this.hat6.y = gameHeight * 0.26;
        this.hat6.anchor.setTo(0.5);
        this.hat6.scale.set(0.5);
        this.hat6.visible = false;

        this.hat7 = this.game.add.sprite(0, 0, 'hat7');
        this.hat7.x = gameWidth * 0.675;
        this.hat7.y = gameHeight * 0.45;
        this.hat7.anchor.setTo(0.5);
        this.hat7.scale.set(0.5);
        this.hat7.visible = false;

        this.hat8 = this.game.add.sprite(0, 0, 'hat8');
        this.hat8.x = gameWidth * 0.675;
        this.hat8.y = gameHeight * 0.45;
        this.hat8.anchor.setTo(0.5);
        this.hat8.scale.set(0.5);
        this.hat8.visible = false;

        this.hat9 = this.game.add.sprite(0, 0, 'hat9');
        this.hat9.x = gameWidth * 0.675;
        this.hat9.y = gameHeight * 0.45;
        this.hat9.anchor.setTo(0.5);
        this.hat9.scale.set(0.5);
        this.hat9.visible = false;

        this.bucket0 = this.game.add.sprite(0, 0, 'bucket0');
        this.bucket0.x = gameWidth * 0.715;
        this.bucket0.y = gameHeight * 0.724;
        this.bucket0.anchor.setTo(0.5);
        this.bucket0.scale.set(0.5);
        this.bucket0.visible = false;

        this.bucket1 = this.game.add.sprite(0, 0, 'bucket1');
        this.bucket1.x = gameWidth * 0.715;
        this.bucket1.y = gameHeight * 0.724;
        this.bucket1.anchor.setTo(0.5);
        this.bucket1.scale.set(0.5);
        this.bucket1.visible = false;

        this.bucket2 = this.game.add.sprite(0, 0, 'bucket2');
        this.bucket2.x = gameWidth * 0.715;
        this.bucket2.y = gameHeight * 0.724;
        this.bucket2.anchor.setTo(0.5);
        this.bucket2.scale.set(0.5);
        this.bucket2.visible = false;

        this.bucket3 = this.game.add.sprite(0, 0, 'bucket3');
        this.bucket3.x = gameWidth * 0.715;
        this.bucket3.y = gameHeight * 0.724;
        this.bucket3.anchor.setTo(0.5);
        this.bucket3.scale.set(0.5);
        this.bucket3.visible = false;

        this.bucket4 = this.game.add.sprite(0, 0, 'bucket4');
        this.bucket4.x = gameWidth * 0.715;
        this.bucket4.y = gameHeight * 0.724;
        this.bucket4.anchor.setTo(0.5);
        this.bucket4.scale.set(0.5);
        this.bucket4.visible = false;

        this.bucket5 = this.game.add.sprite(0, 0, 'bucket5');
        this.bucket5.x = gameWidth * 0.715;
        this.bucket5.y = gameHeight * 0.724;
        this.bucket5.anchor.setTo(0.5);
        this.bucket5.scale.set(0.5);
        this.bucket5.visible = false;

        this.bucket6 = this.game.add.sprite(0, 0, 'bucket6');
        this.bucket6.x = gameWidth * 0.717;
        this.bucket6.y = gameHeight * 0.724;
        this.bucket6.anchor.setTo(0.5);
        this.bucket6.scale.set(0.5);
        this.bucket6.visible = false;

        this.bucket7 = this.game.add.sprite(0, 0, 'bucket7');
        this.bucket7.x = gameWidth * 0.717;
        this.bucket7.y = gameHeight * 0.716;
        this.bucket7.anchor.setTo(0.5);
        this.bucket7.scale.set(0.5);
        this.bucket7.visible = false;

        this.bucket8 = this.game.add.sprite(0, 0, 'bucket8');
        this.bucket8.x = gameWidth * 0.715;
        this.bucket8.y = gameHeight * 0.71;
        this.bucket8.anchor.setTo(0.5);
        this.bucket8.scale.set(0.5);
        this.bucket8.visible = false;

        this.bucket9 = this.game.add.sprite(0, 0, 'bucket9');
        this.bucket9.x = gameWidth * 0.715;
        this.bucket9.y = gameHeight * 0.724;
        this.bucket9.anchor.setTo(0.5);
        this.bucket9.scale.set(0.5);
        this.bucket9.visible = false;

        this.bucket_hand = this.game.add.sprite(0, 0, 'bucket_hand');
        this.bucket_hand.x = gameWidth * 0.685;
        this.bucket_hand.y = gameHeight * 0.62;
        this.bucket_hand.anchor.setTo(0.5);
        this.bucket_hand.scale.set(0.5);
        this.bucket_hand.visible = true;

        this.doneBtnShadow = this.game.add.sprite(0, 0, 'done_btn');
        this.doneBtnShadow.width = this.doneBtnShadow.height = gameWidth * 0.13;
        this.doneBtnShadow.x = gameWidth * 0.075;
        this.doneBtnShadow.y = gameHeight * 0.87;
        this.doneBtnShadow.anchor.set(0.5);
        this.doneBtnShadow.scale.set(0.53);
        this.doneBtnShadow.tint = 0x33FFFF;
        this.doneBtnShadow.alpha = 0;
        this.doneBtnShadow.filters = [blurX, blurY];
        this.doneBtnShadow.visible = false;

        // done button
        this.doneBtn = this.game.add.button(0, 0, 'done_btn', this.donePressed);
        this.doneBtn.name = 'done';
        this.doneBtn.width = this.doneBtn.height = gameWidth * 0.13;
        this.doneBtn.x = gameWidth * 0.075;
        this.doneBtn.y = gameHeight * 0.87;
        this.doneBtn.anchor.setTo(0.5);
        this.doneBtn.inputEnabled = true;
        this.doneBtn.input.pixelPerfectOver = true;
        this.doneBtn.visible = false;

        this.stars = this.game.add.sprite(0, 0, 'stars', this.hiddenPressed);
        this.stars.width = gameWidth * 0.07;
        this.stars.height = gameHeight * 0.08;
        this.stars.anchor.setTo(0.5);
        this.stars.scale.setTo(0.05);
        this.stars.alpha = 0;


    },
    update: function(){
        // buttons hover effect
        if(this.plusBtn.input.pointerOver() && !this.plusBtn.hovered){
            this.plusBtn.hovered = true;
            this.btnHoverBubble(this.plusBtn);
        }
        if(!this.plusBtn.input.pointerOver() && this.plusBtn.hovered){
            this.plusBtn.hovered = false;
        }

        if(this.musicBtn.input.pointerOver() && !this.musicBtn.hovered){
            this.musicBtn.hovered = true;
            this.btnHoverBubble(this.musicBtn);
        }
        if(!this.musicBtn.input.pointerOver() && this.musicBtn.hovered){
            this.musicBtn.hovered = false;
        }

        if(this.backBtn.input.pointerOver() && !this.backBtn.hovered){
            this.backBtn.hovered = true;
            this.btnHoverBubble(this.backBtn);
        }
        if(!this.backBtn.input.pointerOver() && this.backBtn.hovered){
            this.backBtn.hovered = false;
        }

        if(this.doneBtn.input.pointerOver() && !this.doneBtn.hovered){
            this.doneBtn.hovered = true;
            this.btnHoverBubble(this.doneBtn, this.doneBtnShadow);
        }
        if(!this.doneBtn.input.pointerOver() && this.doneBtn.hovered){
            this.doneBtn.hovered = false;
            this.doneBtnShadow.alpha = 0;
        }
        if(!this.doneBtn.hovered){
            this.doneBtnShadow.alpha = 0;
        }

        for(var i in this.wearButtons){
            if(this[this.wearButtons[i]].input.pointerOver() && !this[this.wearButtons[i]].hovered){
                this[this.wearButtons[i]].hovered = true;
                this.btnScaleHover(this[this.wearButtons[i]], this[this.wearButtons[i] + 'Shadow']);
            }
            if(!this[this.wearButtons[i]].input.pointerOver() && this[this.wearButtons[i]].hovered){
                this[this.wearButtons[i]].hovered = false;
                this.btnScaleOut(this[this.wearButtons[i]], this[this.wearButtons[i] + 'Shadow']);
            }
        }

    }
}