"use strict";
window.GirlsGame.state.levels = {
    game: window.GirlsGame.game,
    btnHoverBubble: function(el){
        var self = this;
        var stepTime = 75;
        var t = this.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.3}, stepTime, Phaser.Easing.Bounce.None);
        t.start();

        setTimeout(function(){
            var t2 = self.game.add.tween(el.scale);
            t2.to({x: 0.3, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
            t2.start();

            setTimeout(function(){
                var t3 = self.game.add.tween(el.scale);
                t3.to({x: 0.5, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
                t3.start();

            }, stepTime);
        }, stepTime);

    },
    btnScaleHover: function(el, shadow){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.55, y: 0.55}, 50, Phaser.Easing.Linear.None);
        t.start();

        var t2 = self.game.add.tween(shadow.scale);
        t2.to({x: 0.57, y: 0.57}, 50, Phaser.Easing.Linear.None);
        t2.start();

        // var t3 = self.game.add.tween(shadow);
        // t3.to({alpha: 1}, 50, Phaser.Easing.Linear.None);
        // t3.start();
    },
    btnScaleOut: function(el, shadow){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.5}, 50, Phaser.Easing.Linear.None);
        t.start();

        var t2 = self.game.add.tween(shadow.scale);
        t2.to({x: 0.5, y: 0.5}, 50, Phaser.Easing.Linear.None);
        t2.start();

        // var t3 = self.game.add.tween(shadow);
        // t3.to({alpha: 0}, 50, Phaser.Easing.Linear.None);
        // t3.start();
    },
    btnPressed: function(el){
        var uri = null;
        if(el.name == 'fb'){
            uri = fbUri;
        }
        if(el.name == 'logo'){
            uri = logoUri
        }
        if(el.name == 'plus'){
            uri = plusUri
        }

        var win = window.open(uri, '_blank');
        win.focus();
    },
    menuItemPressed: function(el){
        var self = window.GirlsGame.state.levels;
        if(self.game.audioState) self.game.btnClickAudio.play();
        var elements = [self.logo, self.fbBtn, self.plusBtn, self.musicBtn, self.menuItem1, self.menuItem2, self.menuItem3];
        var shadows = [self.menuItem1Shadow, self.menuItem2Shadow, self.menuItem3Shadow];
        var el = el;
        if(el.unlocked){
            
            for(var i in shadows){
                shadows[i].visible = false;
            }

            for(var i in elements){
                // logo easing
                var tween = self.game.add.tween(elements[i]);
                tween.to({y: -100}, 400, Phaser.Easing.Linear.None);
                tween.start();

                var tween2 = self.game.add.tween(elements[i]);
                tween2.to({alpha: 0}, 400, Phaser.Easing.Linear.None);
                tween2.start();
            }

            if(self.checked1) self.checked1.visible = false;
            if(self.checked2) self.checked2.visible = false;
            if(self.checked3) self.checked3.visible = false;

            setTimeout(function(){
                self.game.state.start('intro' + el.name);
            }, 450);
        }
    },
    musicBtnPressed: function(){
        var self = window.GirlsGame.state.levels;
        if(self.musicBtnOn.visible){
            self.musicBtnOn.visible = false;
            self.musicBtnOff.visible = true;
            self.musicBtn = self.musicBtnOff;
            self.game.audioState = false;
            self.game.bckgAudio.stop();
        }
        else{
            self.musicBtnOn.visible = true;
            self.musicBtnOff.visible = false;
            self.musicBtn = self.musicBtnOn;
            self.game.audioState = true;
            self.game.bckgAudio.play();
        }
    },
    preload: function(){
        this.game.load.script('filterX', './js/lib/blurx.js');
        this.game.load.script('filterY', './js/lib/blury.js');
        this.game.load.script('gray', './js/lib/gray.js');
    },
    create: function(){
        // background
        var bckg = this.game.add.sprite(0, 0, 'game_bckg');
        bckg.width = gameWidth;
        bckg.height = gameHeight;

        var gray = this.game.add.filter('Gray');
        var blurX = this.game.add.filter('BlurX');
        var blurY = this.game.add.filter('BlurY');

        // logo
        this.logo = this.game.add.button(0, 0, 'rainbow_logo', this.btnPressed);
        this.logo.name = 'logo';
        this.logo.width = gameWidth * 0.3;
        this.logo.height = gameHeight * 0.175;
        this.logo.x = gameWidth * 0.15;
        this.logo.y = gameHeight * 0.1;
        this.logo.anchor.setTo(0.5);

        var plusBtn = this.game.add.button(0, 0, 'plus_btn', this.btnPressed);
        plusBtn.name = 'plus';
        plusBtn.width = plusBtn.height = gameWidth * 0.15;
        plusBtn.x = this.game.world.centerX;
        plusBtn.y = gameHeight * 0.85;
        plusBtn.anchor.setTo(0.5);
        plusBtn.inputEnabled = true;
        this.plusBtn = plusBtn;

        // fb button
        this.fbBtn = this.game.add.button(0, 0, 'fb_btn', this.btnPressed);
        this.fbBtn.name = 'fb';
        this.fbBtn.width = this.fbBtn.height = gameWidth * 0.07;
        this.fbBtn.x = gameWidth * 0.84;
        this.fbBtn.y = gameHeight * 0.1;
        this.fbBtn.anchor.setTo(0.5);
        this.fbBtn.inputEnabled = true;

        // music button
        this.musicBtnOn = this.game.add.button(0, 0, 'music_on', this.musicBtnPressed);
        this.musicBtnOn.width = this.musicBtnOn.height = gameWidth * 0.09;
        this.musicBtnOn.x = gameWidth * 0.93;
        this.musicBtnOn.y = gameHeight * 0.1;
        this.musicBtnOn.anchor.setTo(0.5);
        this.musicBtnOn.inputEnabled = true;
        this.musicBtn = this.musicBtnOn;

        this.musicBtnOff = this.game.add.button(0, 0, 'music_off', this.musicBtnPressed);
        this.musicBtnOff.width = this.musicBtnOff.height = gameWidth * 0.09;
        this.musicBtnOff.x = gameWidth * 0.93;
        this.musicBtnOff.y = gameHeight * 0.1;
        this.musicBtnOff.anchor.setTo(0.5);
        this.musicBtnOff.inputEnabled = true;
        this.musicBtnOff.visible = false;

if(!this.game.audioState){
    this.musicBtnOn.visible = false;
    this.musicBtnOff.visible = true;
    this.nusicBtn = this.musicBtnOff;
}

        // menu items
        this.menuItem1Shadow = this.game.add.button(0, 0, 'menu_item1');
        this.menuItem1Shadow.width = this.menuItem1Shadow.height = gameHeight * 0.4;
        this.menuItem1Shadow.x = gameWidth * 0.255;
        this.menuItem1Shadow.y = this.game.world.centerY - gameHeight * 0.05;
        this.menuItem1Shadow.anchor.set(0.5);
        this.menuItem1Shadow.scale.set(0.46);
        this.menuItem1Shadow.tint = 0x33FFFF;
        this.menuItem1Shadow.filters = [blurX, blurY];

        this.menuItem1 = this.game.add.button(0, 0, 'menu_item1', this.menuItemPressed);
        this.menuItem1.width = this.menuItem1.height = gameHeight * 0.4;
        this.menuItem1.x = gameWidth * 0.255;
        this.menuItem1.y = this.game.world.centerY - gameHeight * 0.05;
        this.menuItem1.anchor.setTo(0.5);
        this.menuItem1.inputEnabled = true;
        this.menuItem1.unlocked = true;
        this.menuItem1.name = '1';

        if(levelsUnlocked > 1){
            this.checked1 = this.game.add.sprite(0, 0, 'checked');
            this.checked1.width = this.checked1.height = gameHeight * 0.1;
            this.checked1.x = gameWidth * 0.31;
            this.checked1.y = this.game.world.centerY + gameHeight * 0.1;
            this.checked1.anchor.setTo(0.5);
        }

        this.menuItem2Shadow = this.game.add.button(0, 0, 'menu_item2');
        this.menuItem2Shadow.width = this.menuItem2Shadow.height = gameHeight * 0.4;
        this.menuItem2Shadow.x = this.game.world.centerX;
        this.menuItem2Shadow.y = this.game.world.centerY - gameHeight * 0.05;
        this.menuItem2Shadow.anchor.set(0.5);
        this.menuItem2Shadow.scale.set(0.46);
        this.menuItem2Shadow.tint = 0x33FFFF;
        this.menuItem2Shadow.filters = [blurX, blurY];

        this.menuItem2 = this.game.add.button(0, 0, 'menu_item2', this.menuItemPressed);
        this.menuItem2.width = this.menuItem2.height = gameHeight * 0.4;
        this.menuItem2.x = this.game.world.centerX;
        this.menuItem2.y = this.game.world.centerY - gameHeight * 0.05;
        this.menuItem2.anchor.setTo(0.5);
        this.menuItem2.scale.set(0.5);
        this.menuItem2.inputEnabled = true;
        this.menuItem2.name = '2';
        this.menuItem2.unlocked = true;
        if(levelsUnlocked < 2){
            this.menuItem2.filters = [gray];
            this.menuItem2.unlocked = false;   
        }

        if(levelsUnlocked > 2){
            this.checked2 = this.game.add.sprite(0, 0, 'checked');
            this.checked2.width = this.checked2.height = gameHeight * 0.1;
            this.checked2.x = this.game.world.centerX + gameWidth * 0.05;
            this.checked2.y = this.game.world.centerY + gameHeight * 0.1;
            this.checked2.anchor.setTo(0.5);
        }

        this.menuItem3Shadow = this.game.add.button(0, 0, 'menu_item3');
        this.menuItem3Shadow.width = this.menuItem3Shadow.height = gameHeight * 0.4;
        this.menuItem3Shadow.x = gameWidth * 0.75;
        this.menuItem3Shadow.y = this.game.world.centerY - gameHeight * 0.05;
        this.menuItem3Shadow.anchor.set(0.5);
        this.menuItem3Shadow.scale.set(0.46);
        this.menuItem3Shadow.tint = 0x33FFFF;
        this.menuItem3Shadow.filters = [blurX, blurY];

        this.menuItem3 = this.game.add.button(0, 0, 'menu_item3', this.menuItemPressed);
        this.menuItem3.width = this.menuItem3.height = gameHeight * 0.4;
        this.menuItem3.x = gameWidth * 0.75;
        this.menuItem3.y = this.game.world.centerY - gameHeight * 0.05;
        this.menuItem3.anchor.setTo(0.5);
        this.menuItem3.unlocked = true;
        this.menuItem3.name = '3';

        if(levelsUnlocked > 3){
            this.checked3 = this.game.add.sprite(0, 0, 'checked');
            this.checked3.width = this.checked3.height = gameHeight * 0.1;
            this.checked3.x = gameWidth * 0.79;
            this.checked3.y = this.game.world.centerY + gameHeight * 0.1;
            this.checked3.anchor.setTo(0.5);
        }

        if(levelsUnlocked < 3){
            this.menuItem3.filters = [gray];
            this.menuItem3.unlocked = false;   
        }

    },
    update: function(){
        
        // buttons hover effect
        if(this.plusBtn.input.pointerOver() && !this.plusBtn.hovered){
            this.plusBtn.hovered = true;
            this.btnHoverBubble(this.plusBtn, this.plusBtnShadow);
        }
        if(!this.plusBtn.input.pointerOver() && this.plusBtn.hovered){
            this.plusBtn.hovered = false;
        }

        if(this.musicBtn.input.pointerOver() && !this.musicBtn.hovered){
            this.musicBtn.hovered = true;
            this.btnHoverBubble(this.musicBtn);
        }
        if(!this.musicBtn.input.pointerOver() && this.musicBtn.hovered){
            this.musicBtn.hovered = false;
        }

        // menu items hover
        if(this.menuItem1.input.pointerOver() && !this.menuItem1.hovered){
            this.menuItem1.hovered = true;
            this.btnScaleHover(this.menuItem1, this.menuItem1Shadow);
        }
        if(!this.menuItem1.input.pointerOver() && this.menuItem1.hovered){
            this.menuItem1.hovered = false;
            this.btnScaleOut(this.menuItem1, this.menuItem1Shadow);
        }

        if(this.menuItem2.unlocked){
            if(this.menuItem2.input.pointerOver() && !this.menuItem2.hovered){
                this.menuItem2.hovered = true;
                this.btnScaleHover(this.menuItem2, this.menuItem2Shadow);
            }
            if(!this.menuItem2.input.pointerOver() && this.menuItem2.hovered){
                this.menuItem2.hovered = false;
                this.btnScaleOut(this.menuItem2, this.menuItem2Shadow);
            }
        }
        

        if(this.menuItem3.unlocked){
            if(this.menuItem3.input.pointerOver() && !this.menuItem3.hovered){
                this.menuItem3.hovered = true;
                this.btnScaleHover(this.menuItem3, this.menuItem3Shadow);
            }
            if(!this.menuItem3.input.pointerOver() && this.menuItem3.hovered){
                this.menuItem3.hovered = false;
                this.btnScaleOut(this.menuItem3, this.menuItem3Shadow);
            }
        }
    }
}