"use strict";
window.GirlsGame.state.load = {
    firstClick: true,
    game: window.GirlsGame.game,
    percentLabel: null,
    updateProgressBar: function(){
        this.game.loaderBarFilled.width = gameWidth * 0.25 * this.game.load.progress * 0.01;
    },
    loadComplete: function(){
        this.game.loaderBar.visible = false;
        this.game.loaderBarFilled.visible = false;
        this.game.loaderBckg.visible = false;
        this.game.playBtn.visible = true;
    },
    bckgPressed: function(){
        var self = window.GirlsGame.state.load;
        if(self.firstClick && self.game.device.desktop === false){
            self.firstClick = false;
            if (self.game.scale.compatibility.supportsFullScreen) {
                self.game.scale.startFullScreen();
            }
            return;
        }
        var win = window.open('http://www.rainbowdressup.com/?utm_source=rainbowdressup.com&utm_medium=preloader&utm_campaign=little-red-forest-adventures', '_blank');
        win.focus();
    },
    playPressed: function(){

        var self = window.GirlsGame.state.load;
        if (self.firstClick && self.game.device.desktop === false) {
            if(self.game.scale.compatibility.supportsFullScreen){
                self.game.scale.startFullScreen();
            }
        }
        // logo easing
        var tween = this.game.add.tween(this.game.logo);
        tween.to({y: -100}, 400, Phaser.Easing.Linear.None);
        tween.start();

        var tween2 = this.game.add.tween(this.game.logo.scale);
        tween2.to({x: 0.9, y: 0.9}, 400, Phaser.Easing.Linear.None);
        tween2.start();

        // play btn easing
        var tween3 = this.game.add.tween(this.game.playBtn);
        tween3.to({y: -100}, 450, Phaser.Easing.Linear.None);
        tween3.start();

        var tween4 = this.game.add.tween(this.game.playBtn.scale);
        tween4.to({x: 0.9, y: 0.9}, 400, Phaser.Easing.Linear.None);
        tween4.start();

        // hide categories buttons
        for(var i in this.game.categories){
            this.game.categories[i].visible = false;
        }

        setTimeout(function(){
            self.game.state.start('main_menu');
        }, 450);
    },
    bubbleScaleHover: function(el){
        el.tint = 0xc38ec7;
    },
    bubbleScaleOut: function(el){
        el.tint = 0xffffff;
    },
    btnScaleHover: function(el){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.75, y: 0.75}, 50, Phaser.Easing.Linear.None);
        t.start();
    },
    btnScaleOut: function(el){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.7, y: 0.7}, 50, Phaser.Easing.Linear.None);
        t.start();
    },
    categoryPressed: function(el){
        var uri = null;
        if(el.category == 'pets'){
            uri = 'http://www.rainbowdressup.com/pets-games/?utm_source=rainbowdressup.com&utm_medium=preloader-Pets-Games&utm_campaign=little-red-forest-adventures';
        }

        if(el.category == 'dress-up'){
            uri = 'http://www.rainbowdressup.com/dressup-games/?utm_source=rainbowdressup.com&utm_medium=preloader-Dressup-Games&utm_campaign=little-red-forest-adventures';
        }

        if(el.category == 'decoration'){
            uri = 'http://www.rainbowdressup.com/coloring-games/?utm_source=rainbowdressup.com&utm_medium=preloader-Decoration-Games&utm_campaign=little-red-forest-adventures';
        }

        if(el.category == 'make-up'){
            uri = 'http://www.rainbowdressup.com/make-up-games/?utm_source=rainbowdressup.com&utm_medium=preloader-Makeup-Games&utm_campaign=little-red-forest-adventures';
        }

        if(el.category == 'cooking'){
            uri = 'http://www.rainbowdressup.com/cooking-games/?utm_source=rainbowdressup.com&utm_medium=preloader-Cooking-Games&utm_campaign=little-red-forest-adventures';
        }

        if(el.category == 'wedding'){
            uri = 'http://www.rainbowdressup.com/wedding-games/?utm_source=rainbowdressup.com&utm_medium=preloader-Wedding-Games&utm_campaign=little-red-forest-adventures';
        }

        var win = window.open(uri, '_blank');
        win.focus();
    },
    categoryOnLoad: function(el, timeout){
        
        var self = this;
        setTimeout(function(){
            el.visible = true;
            var s = self.game.add.tween(el.scale);
            s.to({x: 0.7, y:0.7}, 100, Phaser.Easing.Linear.None);
            s.start();
            setTimeout(function(){
                var s2 = self.game.add.tween(el.scale);
                s2.to({x: 0.5, y:0.5}, 100, Phaser.Easing.Linear.None);
                s2.onComplete.addOnce(function(){
                    var tween = self.game.add.tween(el.scale).to( { x:0.55, y:0.55 }, 700, "Linear", true, 0, -1);
                    tween.yoyo(true, 100);
                }, this);
                s2.start();
            }, 200);

        }, timeout);
    },
    preload: function(){
        // loader background
        var loaderBckg = this.game.add.button(0, 0, 'sky_bckg', this.bckgPressed);
        loaderBckg.width = gameWidth;
        loaderBckg.height = gameHeight;

        // add logo
        var logo = this.game.add.button(0, 0, 'logo', this.bckgPressed);
        logo.width = gameWidth * 0.5;
        logo.height = gameHeight * 0.4;
        logo.x = this.game.world.centerX;
        logo.y = this.game.world.centerY;
        logo.anchor.setTo(0.5);
        this.game.logo = logo;

        // add loader bar
        var loaderBar = this.game.add.sprite(0, 0, 'loading_bar');
        loaderBar.width = gameWidth * 0.25;
        loaderBar.height = gameHeight * 0.03;
        loaderBar.x = this.game.world.centerX - loaderBar.width/2;
        loaderBar.y = gameHeight/2 + gameHeight * 0.125;
        this.game.loaderBar = loaderBar;

        var loaderBckg = this.game.add.sprite(0, 0, 'loading_bar_fill');
        loaderBckg.width = gameWidth * 0.25;
        loaderBckg.height = gameHeight * 0.03;
        loaderBckg.x = this.game.world.centerX - loaderBckg.width/2.02;
        loaderBckg.y = gameHeight/2 + gameHeight * 0.125;
        loaderBckg.width = gameWidth * 0.1;
        this.game.loaderBckg = loaderBckg;

        var loaderBarFilled = this.game.add.sprite(0, 0, 'loading_bar_fill');
        loaderBarFilled.width = gameWidth * 0.25;
        loaderBarFilled.height = gameHeight * 0.03;
        loaderBarFilled.x = this.game.world.centerX - loaderBarFilled.width/2.05;
        loaderBarFilled.y = gameHeight/2 + gameHeight * 0.125;
        loaderBarFilled.width = 0;
        this.game.loaderBarFilled = loaderBarFilled;

        // add play button
        var playBtn = this.game.add.button(0, 0, 'preloader_play_btn', this.playPressed);
        playBtn.width = gameWidth * 0.1;
        playBtn.height = gameHeight * 0.1;
        playBtn.x = this.game.world.centerX;
        playBtn.y = gameHeight/2 + gameHeight * 0.15;
        playBtn.visible = false;
        this.game.playBtn = playBtn;
        this.playBtn = playBtn;
        this.playBtn.anchor.set(0.5);
        this.playBtn.scale.set(0.7);

        // add category buttons
        // pets
        var categorySide = gameWidth * 0.2;
        var pets = this.game.add.button(0, 0, 'pets_btn', this.categoryPressed);
        pets.category = 'pets';
        pets.width = pets.height = categorySide;
        pets.x = gameWidth * 0.3;
        pets.y = gameHeight * 0.15;
        this.categoryOnLoad(pets, 0);

        // dress-up
        var dressUp = this.game.add.button(0, 0, 'dress_up_btn', this.categoryPressed);
        dressUp.category = 'dress-up';
        dressUp.width = dressUp.height = categorySide;
        dressUp.x = gameWidth * 0.68;
        dressUp.y = gameHeight * 0.15;
        this.categoryOnLoad(dressUp, 200);

        // make-up
        var makeUp = this.game.add.button(0, 0, 'make_up_btn', this.categoryPressed);
        makeUp.category = 'make-up';
        makeUp.width = makeUp.height = categorySide;
        makeUp.x = gameWidth * 0.85;
        makeUp.y = gameHeight * 0.45;
        this.categoryOnLoad(makeUp, 400);

        // wedding
        var wedding = this.game.add.button(0, 0, 'wedding_btn', this.categoryPressed);
        wedding.category = 'wedding';
        wedding.width = wedding.height = categorySide;
        wedding.x = gameWidth * 0.7;
        wedding.y = gameHeight * 0.82;
        this.categoryOnLoad(wedding, 600);

        // cooking
        var cooking = this.game.add.button(0, 0, 'cooking_btn', this.categoryPressed);
        cooking.category = 'cooking';
        cooking.width = cooking.height = categorySide;
        cooking.x = gameWidth * 0.3;
        cooking.y = gameHeight * 0.82;
        this.categoryOnLoad(cooking, 800);

        // decoration
        var decoration = this.game.add.button(0, 0, 'decoration_btn', this.categoryPressed);
        decoration.category = 'decoration';
        decoration.width = decoration.height = categorySide;
        decoration.x = gameWidth * 0.15;
        decoration.y = gameHeight * 0.45;
        this.decoration = decoration;
        this.categoryOnLoad(decoration, 1000);        

        var categories = [pets, dressUp, makeUp, wedding, cooking, decoration];
        this.game.categories = categories;
        for(var i in categories){
            // categories[i].scale.setTo(0.7);
            categories[i].anchor.setTo(0.5, 0.5);
            categories[i].visible = false;
        }

        // update loader event
        this.game.load.onFileComplete.add(this.updateProgressBar, this);
        this.game.load.onLoadComplete.add(this.loadComplete, this);
        
        this.game.load.image('pie', 'assets/sprites/pie.png');
        this.game.load.image('hidden_obj2', 'assets/sprites/hidden_obj2.png');
        this.game.load.image('hidden_obj3', 'assets/sprites/hidden_obj3.png');
        this.game.load.image('hidden_obj4', 'assets/sprites/hidden_obj4.png');
        this.game.load.image('hidden_obj5', 'assets/sprites/hidden_obj5.png');
        this.game.load.image('hidden_obj6', 'assets/sprites/hidden_obj6.png');
        this.game.load.image('hidden_obj7', 'assets/sprites/hidden_obj7.png');
        this.game.load.image('hidden_obj8', 'assets/sprites/hidden_obj8.png');
        this.game.load.image('hidden_obj9', 'assets/sprites/hidden_obj9.png');
        this.game.load.image('hidden_obj10', 'assets/sprites/hidden_obj10.png');
        this.game.load.image('hidden_obj11', 'assets/sprites/hidden_obj11.png');
        this.game.load.image('hidden_obj12', 'assets/sprites/hidden_obj12.png');
        this.game.load.image('hidden_obj13', 'assets/sprites/hidden_obj13.png');
        this.game.load.image('hidden_obj14', 'assets/sprites/hidden_obj14.png');
        this.game.load.image('hidden_obj15', 'assets/sprites/hidden_obj15.png');
        this.game.load.image('hidden_obj16', 'assets/sprites/hidden_obj16.png');
        this.game.load.image('hidden_obj17', 'assets/sprites/hidden_obj17.png');
        this.game.load.image('hidden_obj18', 'assets/sprites/hidden_obj18.png');
        this.game.load.image('hidden_obj19', 'assets/sprites/hidden_obj19.png');
        this.game.load.image('hidden_obj20', 'assets/sprites/hidden_obj20.png');
        this.game.load.image('main_menu_bckg', 'assets/sprites/main_menu_bckg.png');
        this.game.load.image('msg_bckg', 'assets/sprites/msg_bckg.png');
        this.game.load.image('game_bckg', 'assets/sprites/game_bckg.png');
        this.game.load.image('rainbow_logo', 'assets/sprites/rainbow_logo.png');
        this.game.load.image('play_btn', 'assets/sprites/play_btn.png');
        this.game.load.image('plus_btn', 'assets/sprites/plus_btn.png');
        this.game.load.image('fb_btn', 'assets/sprites/fb_btn.png');
        this.game.load.image('music_on', 'assets/sprites/music_on.png');
        this.game.load.image('music_off', 'assets/sprites/music_off.png');
        this.game.load.image('logo_icon', 'assets/sprites/logo_icon.png');
        this.game.load.image('girl_head', 'assets/sprites/girl_head.png');
        this.game.load.image('closed_eyes', 'assets/sprites/closed_eyes.png');
        this.game.load.image('wolf', 'assets/sprites/wolf.png');
        this.game.load.image('intro1_txt', 'assets/sprites/intro1_txt.png');
        this.game.load.image('intro2_txt', 'assets/sprites/intro2_txt.png');
        this.game.load.image('intro2_1_txt', 'assets/sprites/intro2_1_txt.png');
        this.game.load.image('intro3_txt', 'assets/sprites/intro3_txt.png');
        this.game.load.image('intro3_1_txt', 'assets/sprites/intro3_1_txt.png');
        this.game.load.image('great_txt', 'assets/sprites/great_txt.png');
        this.game.load.image('next_arrow', 'assets/sprites/next_arrow.png');
        this.game.load.image('next_btn', 'assets/sprites/next_btn.png');

        this.game.load.image('menu_item1', 'assets/sprites/menu_item1.png');
        this.game.load.image('menu_item2', 'assets/sprites/menu_item2.png');
        this.game.load.image('menu_item3', 'assets/sprites/menu_item3.png');

        this.game.load.image('level1_middle_layer', 'assets/sprites/level1_middle_layer.png');
        this.game.load.image('level1_upper_layer', 'assets/sprites/level1_upper_layer.png');
        this.game.load.image('back_btn', 'assets/sprites/back_btn.png');
        this.game.load.image('hint_btn', 'assets/sprites/hint_btn.png');
        this.game.load.image('items_left', 'assets/sprites/items_left.png');
        this.game.load.image('star2', 'assets/sprites/star2.png');
        this.game.load.image('stars', 'assets/sprites/stars.png');

        this.game.load.image('level2_bckg', 'assets/sprites/level2_bckg.png');
        this.game.load.image('back_play_btn', 'assets/sprites/back_play_btn.png');
        this.game.load.image('bucket_btn', 'assets/sprites/bucket_btn.png');
        this.game.load.image('shoes_btn', 'assets/sprites/shoes_btn.png');
        this.game.load.image('stockings_btn', 'assets/sprites/stockings_btn.png');
        this.game.load.image('hat_btn', 'assets/sprites/hat_btn.png');
        this.game.load.image('dress_btn', 'assets/sprites/dress_btn.png');
        this.game.load.image('dress_btn', 'assets/sprites/dress_btn.png');
        this.game.load.image('hair_btn', 'assets/sprites/hair_btn.png');
        this.game.load.image('x_btn', 'assets/sprites/x_btn.png');
        this.game.load.image('stockings', 'assets/sprites/stockings.png');
        this.game.load.image('shoes', 'assets/sprites/shoes.png');
        this.game.load.image('dress-up_hand', 'assets/sprites/dress-up_hand.png');
        this.game.load.image('dress0', 'assets/sprites/dress0.png');
        this.game.load.image('dress1', 'assets/sprites/dress1.png');
        this.game.load.image('dress2', 'assets/sprites/dress2.png');
        this.game.load.image('dress3', 'assets/sprites/dress3.png');
        this.game.load.image('dress4', 'assets/sprites/dress4.png');
        this.game.load.image('dress5', 'assets/sprites/dress5.png');
        this.game.load.image('dress6', 'assets/sprites/dress6.png');
        this.game.load.image('dress7', 'assets/sprites/dress7.png');
        this.game.load.image('dress8', 'assets/sprites/dress8.png');
        this.game.load.image('dress9', 'assets/sprites/dress9.png');
        this.game.load.image('hair0', 'assets/sprites/hair0.png');
        this.game.load.image('hair1', 'assets/sprites/hair1.png');
        this.game.load.image('hair2', 'assets/sprites/hair2.png');
        this.game.load.image('hair3', 'assets/sprites/hair3.png');
        this.game.load.image('hair4', 'assets/sprites/hair4.png');
        this.game.load.image('hair5', 'assets/sprites/hair5.png');
        this.game.load.image('hair6', 'assets/sprites/hair6.png');
        this.game.load.image('hair7', 'assets/sprites/hair7.png');
        this.game.load.image('hair8', 'assets/sprites/hair8.png');
        this.game.load.image('bucket0', 'assets/sprites/bucket0.png');
        this.game.load.image('bucket1', 'assets/sprites/bucket1.png');
        this.game.load.image('bucket2', 'assets/sprites/bucket2.png');
        this.game.load.image('bucket3', 'assets/sprites/bucket3.png');
        this.game.load.image('bucket4', 'assets/sprites/bucket4.png');
        this.game.load.image('bucket5', 'assets/sprites/bucket5.png');
        this.game.load.image('bucket6', 'assets/sprites/bucket6.png');
        this.game.load.image('bucket7', 'assets/sprites/bucket7.png');
        this.game.load.image('bucket8', 'assets/sprites/bucket8.png');
        this.game.load.image('bucket9', 'assets/sprites/bucket9.png');
        this.game.load.image('bucket_hand', 'assets/sprites/bucket_hand.png');
        this.game.load.image('hat_bckg0', 'assets/sprites/hat_bckg0.png');
        this.game.load.image('hat_bckg1', 'assets/sprites/hat_bckg1.png');
        this.game.load.image('hat_bckg2', 'assets/sprites/hat_bckg2.png');
        this.game.load.image('hat_bckg3', 'assets/sprites/hat_bckg3.png');
        this.game.load.image('hat_bckg4', 'assets/sprites/hat_bckg4.png');
        this.game.load.image('hat_bckg5', 'assets/sprites/hat_bckg5.png');
        this.game.load.image('hat_bckg6', 'assets/sprites/hat_bckg6.png');
        this.game.load.image('hat_bckg7', 'assets/sprites/hat_bckg7.png');
        this.game.load.image('hat0', 'assets/sprites/hat0.png');
        this.game.load.image('hat1', 'assets/sprites/hat1.png');
        this.game.load.image('hat2', 'assets/sprites/hat2.png');
        this.game.load.image('hat3', 'assets/sprites/hat3.png');
        this.game.load.image('hat4', 'assets/sprites/hat4.png');
        this.game.load.image('hat5', 'assets/sprites/hat5.png');
        this.game.load.image('hat6', 'assets/sprites/hat6.png');
        this.game.load.image('hat7', 'assets/sprites/hat7.png');
        this.game.load.image('hat8', 'assets/sprites/hat8.png');
        this.game.load.image('hat9', 'assets/sprites/hat9.png');
        this.game.load.image('done_btn', 'assets/sprites/done_btn.png');
        this.game.load.image('level3_bckg', 'assets/sprites/level3_bckg.png');
        this.game.load.image('time_green_bckg', 'assets/sprites/time_green_bckg.png');
        this.game.load.image('time_red_bckg', 'assets/sprites/time_red_bckg.png');
        this.game.load.image('timer_bckg', 'assets/sprites/timer_bckg.png');
        this.game.load.image('arrow', 'assets/sprites/arrow.png');
        this.game.load.image('hidden_girl', 'assets/sprites/hidden_girl.png');
        this.game.load.image('level3_layer1', 'assets/sprites/level3_layer1.png');
        this.game.load.image('level3_layer2', 'assets/sprites/level3_layer2.png');
        this.game.load.image('zbang', 'assets/sprites/zbang.png');
        this.game.load.image('heart_gray', 'assets/sprites/heart_gray.png');
        this.game.load.image('red_arrow', 'assets/sprites/red_arrow.png');
        this.game.load.image('checked', 'assets/sprites/checked.png');
        this.game.load.image('try_again', 'assets/sprites/try_again.png');
        this.game.load.image('try_again_btn', 'assets/sprites/try_again_btn.png');
        this.game.load.image('table_txt', 'assets/sprites/table_txt.png');
        this.game.load.image('checkpoint1', 'assets/sprites/checkpoint1.png');
        this.game.load.image('checkpoint2', 'assets/sprites/checkpoint2.png');
        this.game.load.image('checkpoint3', 'assets/sprites/checkpoint3.png');
        this.game.load.image('congratz', 'assets/sprites/congratz.png');

        this.game.load.spritesheet('wolfs', 'assets/sprites/wolfs.png', 254, 174);
        this.game.load.spritesheet('girl_sprites', 'assets/sprites/girl_sprites.png', 220, 210);
        this.game.load.spritesheet('legs', 'assets/sprites/legs.png', 72, 41);
        this.game.load.spritesheet('numbers', 'assets/sprites/numbers.png', 160.8, 116.5, 20);

        this.game.load.audio('soundtrack', 'assets/audio/8_soundtrack.mp3');
        this.game.load.audio('btn_click', 'assets/audio/5_clic.mp3');
        this.game.load.audio('hidden_effect', 'assets/audio/9_sc.mp3');
        this.game.load.audio('wear_effect', 'assets/audio/3_butt.mp3');
        this.game.load.audio('girl_move', 'assets/audio/1_stst.mp3');
        this.game.load.audio('wolf_effect', 'assets/audio/4_wolfGen.mp3');
        this.game.load.audio('zbang', 'assets/audio/7_bitte.mp3');
    },

    create: function(){},

    update: function(){
        if(this.playBtn.input.pointerOver() && !this.playBtn.hovered){
            this.playBtn.hovered = true;
            this.btnScaleHover(this.playBtn);
        }
        if(!this.playBtn.input.pointerOver() && this.playBtn.hovered){
            this.playBtn.hovered = false;
            this.btnScaleOut(this.playBtn);
        }

        for(var i in this.game.categories){
            if(this.game.categories[i].input.pointerOver() && !this.game.categories[i].hovered){
                this.game.categories[i].hovered = true;
                this.bubbleScaleHover(this.game.categories[i]);
            }
            if(!this.game.categories[i].input.pointerOver() && this.game.categories[i].hovered){
                this.game.categories[i].hovered = false;
                this.bubbleScaleOut(this.game.categories[i]);
            }
        }
    }
}