"use strict";
window.GirlsGame.state.main_menu = {
    game: window.GirlsGame.game,
    btnHoverBubble: function(el, shadow){
        var self = this;
        var stepTime = 75;
        var t = this.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.3}, stepTime, Phaser.Easing.Bounce.None);
        t.start();

        setTimeout(function(){
            var t2 = self.game.add.tween(el.scale);
            t2.to({x: 0.3, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
            t2.start();

            setTimeout(function(){
                var t3 = self.game.add.tween(el.scale);
                t3.to({x: 0.5, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
                t3.onComplete.addOnce(function(){
                    if(el.hovered){
                        var t4 = self.game.add.tween(shadow);
                        t4.to({alpha: 1}, stepTime * 3, Phaser.Easing.Linear.None);
                        t4.start();
                    }
                }, this);
                t3.start();

            }, stepTime);
        }, stepTime);

    },
    btnScaleHover: function(el, shadow){
        var self = this;

        var t = self.game.add.tween(el.scale);
        t.to({x: 0.55, y: 0.55}, 50, Phaser.Easing.Linear.None);
        // t.onComplete.addOnce(function(){
        //     if(el.hovered){
        //         var t2 = self.game.add.tween(shadow);
        //         t2.to({alpha: 1}, 150, Phaser.Easing.Linear.None);
        //         t2.start();
        //     }
        // }, this);
        t.start();
    },
    btnPressed: function(el){
        var uri = null;
        if(el.name == 'fb'){
            uri = fbUri;
        }
        if(el.name == 'logo'){
            uri = logoUri
        }
        if(el.name == 'plus'){
            uri = plusUri
        }

        var win = window.open(uri, '_blank');
        win.focus();
    },
    musicBtnPressed: function(){
        var self = window.GirlsGame.state.main_menu;
        if(self.musicBtnOn.visible){
            self.musicBtnOn.visible = false;
            self.musicBtnOff.visible = true;
            self.musicBtn = self.musicBtnOff;
            self.game.audioState = false;
            self.game.bckgAudio.stop();
        }
        else{
            self.musicBtnOn.visible = true;
            self.musicBtnOff.visible = false;
            self.musicBtn = self.musicBtnOn;
            self.game.audioState = true;
            self.game.bckgAudio.play();
        }
    },
    playPressed: function(){

        var self = window.GirlsGame.state.main_menu;
        if(self.game.audioState) self.game.btnClickAudio.play();
        var elements = [self.logo, self.fbBtn, self.playBtn, self.plusBtn, self.musicBtn];
        var shadows = [self.fbBtnShadow, self.playBtnShadow, self.plusBtnShadow, self.musicBtnShadow];

        for(var i in shadows){
            shadows[i].visible = false;
        }

        for(var i in elements){
            // logo easing
            var tween = self.game.add.tween(elements[i]);
            tween.to({y: -100}, 400, Phaser.Easing.Linear.None);
            tween.start();

            var tween2 = self.game.add.tween(elements[i]);
            tween2.to({alpha: 0}, 400, Phaser.Easing.Linear.None);
            tween2.start();
        }

        setTimeout(function(){
            self.game.state.start('levels');
        }, 450);
    },
    preload: function(){
        this.game.load.script('filterX', './js/lib/blurx.js');
        this.game.load.script('filterY', './js/lib/blury.js');
    },
    create: function(){
        this.game.btnClickAudio = this.game.add.audio('btn_click');
        this.game.hiddenEffectAudio = this.game.add.audio('hidden_effect');
        this.game.wearEffectAudio = this.game.add.audio('wear_effect');
        this.game.girlMoveEffect = this.game.add.audio('girl_move');
        this.game.wolfEffect = this.game.add.audio('wolf_effect');
        this.game.zbangEffect = this.game.add.audio('zbang');
        this.game.bckgAudio = this.game.add.audio('soundtrack');
        this.game.bckgAudio.play('', 0, 1);

    	// background
        var bckg = this.game.add.sprite(0, 0, 'main_menu_bckg');
        bckg.width = gameWidth;
        bckg.height = gameHeight;

        // logo icon
        var logoIcon = this.game.add.button(0, 0, 'logo_icon');
        logoIcon.width = gameWidth * 0.6;
        logoIcon.height = gameHeight * 0.78;
        logoIcon.x = this.game.world.centerX;
        logoIcon.y = this.game.world.centerY + gameHeight * 0.4;
        logoIcon.anchor.setTo(0.5);
        logoIcon.scale.setTo(0.1, 0.1);
        this.game.logoIcon = logoIcon;

        var tween = this.game.add.tween(logoIcon.scale);
        tween.to({x: 0.5, y: 0.5}, 1000, Phaser.Easing.Linear.None);
        tween.start();

        tween = this.game.add.tween(logoIcon);
        tween.to({y: this.game.world.centerY - gameHeight * 0.08}, 1000, Phaser.Easing.Linear.None);
        tween.start();

        var wolf = this.game.add.sprite(0, 0, 'wolf');
        wolf.width = gameWidth * 0.375;
        wolf.height = gameHeight * 0.55;
        wolf.x = gameWidth * 0.632;
        wolf.y = gameHeight * 0.45;

        // girl
        var girl = this.game.add.sprite(0, 0, 'girl_head');
        girl.width = gameWidth * 0.44;
        girl.height = gameHeight * 0.55;
        girl.x = gameWidth * 0.46;
        girl.y = gameHeight * 0.8;
        girl.anchor.setTo(0.5);
        girl.scale.setTo(0.1, 0.1);
        girl.visible = false;
        this.game.girl = girl;

        // eyes
        var eyes = this.game.add.sprite(0, 0, 'closed_eyes');
        eyes.width = gameWidth * 0.09;
        eyes.height = gameHeight * 0.1;
        eyes.x = gameWidth * 0.165;
        eyes.y = gameHeight * 0.4;
        eyes.visible = false;


        var self = this;
        setTimeout(function(){
        	
        	girl.visible = true;
	        tween = self.game.add.tween(girl.scale);
	        tween.to({x: 0.5, y: 0.5}, 1000, Phaser.Easing.Linear.None);
	        tween.start();

	        tween = self.game.add.tween(girl);
	        tween.to({x: gameWidth * 0.26, y: gameHeight * 0.52}, 1000, Phaser.Easing.Linear.None);
	        tween.start();
	        
	        setTimeout(function(){
	        	var s = self.game.add.tween(girl).to( { y: girl.y + gameHeight * 0.01 }, 700, "Linear", true, 0, -1);
            	s.yoyo(true, 700);

            	setInterval(function(){
		        	eyes.visible = true;
		        	setTimeout(function(){
		        		eyes.visible = false;
		        	}, 100);
		        	setTimeout(function(){
		        		eyes.visible = true;
		        	}, 200);
		        	setTimeout(function(){
		        		eyes.visible = false;
		        	}, 400);

		        }, 2100);
	        }, 2000);

	        // play button
        }, 1000);

        this.playBtnShadow = this.game.add.sprite(0, 0, 'play_btn');
        this.playBtnShadow.width = this.playBtnShadow.height = gameWidth * 0.15;
        this.playBtnShadow.x = this.game.world.centerX;
        this.playBtnShadow.y = gameHeight * 0.85;
        this.playBtnShadow.anchor.set(0.5);
        this.playBtnShadow.scale.set(0.53);
        this.playBtnShadow.tint = 0x33FFFF;
        this.playBtnShadow.alpha = 0;

        var blurX = this.game.add.filter('BlurX');
        var blurY = this.game.add.filter('BlurY');
        this.playBtnShadow.filters = [blurX, blurY];

        var playBtn = this.game.add.button(0, 0, 'play_btn', this.playPressed);
        playBtn.width = playBtn.height = gameWidth * 0.15;
        playBtn.x = this.game.world.centerX;
        playBtn.y = gameHeight * 0.85;
        playBtn.anchor.setTo(0.5);
        playBtn.inputEnabled = true;
        this.playBtn = playBtn;

        this.plusBtnShadow = this.game.add.sprite(0, 0, 'plus_btn');
        this.plusBtnShadow.width = this.plusBtnShadow.height = gameWidth * 0.13;
        this.plusBtnShadow.x = gameWidth * 0.9;
        this.plusBtnShadow.y = gameHeight * 0.85;
        this.plusBtnShadow.anchor.set(0.5);
        this.plusBtnShadow.scale.set(0.53);
        this.plusBtnShadow.tint = 0x33FFFF;
        this.plusBtnShadow.alpha = 0;
        this.plusBtnShadow.filters = [blurX, blurY];

        // plus button
        this.plusBtn = this.game.add.button(0, 0, 'plus_btn', this.btnPressed);
        this.plusBtn.name = 'plus';
        this.plusBtn.width = this.plusBtn.height = gameWidth * 0.13;
        this.plusBtn.x = gameWidth * 0.9;
        this.plusBtn.y = gameHeight * 0.85;
        this.plusBtn.anchor.setTo(0.5);
        this.plusBtn.inputEnabled = true;
        this.plusBtn.input.pixelPerfectOver = true;

        this.fbBtnShadow = this.game.add.sprite(0, 0, 'fb_btn');
        this.fbBtnShadow.width = this.fbBtnShadow.height = gameWidth * 0.07;
        this.fbBtnShadow.x = gameWidth * 0.84;
        this.fbBtnShadow.y = gameHeight * 0.1;
        this.fbBtnShadow.anchor.set(0.5);
        this.fbBtnShadow.scale.set(0.55);
        this.fbBtnShadow.tint = 0x66FFFF;
        this.fbBtnShadow.alpha = 0;
        this.fbBtnShadow.filters = [blurX, blurY];

        // fb button
        this.fbBtn = this.game.add.button(0, 0, 'fb_btn', this.btnPressed);
        this.fbBtn.name = 'fb';
        this.fbBtn.width = this.fbBtn.height = gameWidth * 0.07;
        this.fbBtn.x = gameWidth * 0.84;
        this.fbBtn.y = gameHeight * 0.1;
        this.fbBtn.anchor.setTo(0.5);
        this.fbBtn.inputEnabled = true;

        this.musicBtnShadow = this.game.add.sprite(0, 0, 'music_on');
        this.musicBtnShadow.width = this.musicBtnShadow.height = gameWidth * 0.09;
        this.musicBtnShadow.x = gameWidth * 0.93;
        this.musicBtnShadow.y = gameHeight * 0.1;
        this.musicBtnShadow.anchor.set(0.5);
        this.musicBtnShadow.scale.set(0.53);
        this.musicBtnShadow.tint = 0x33FFFF;
        this.musicBtnShadow.alpha = 0;
        this.musicBtnShadow.filters = [blurX, blurY];

        // music button
        this.musicBtnOn = this.game.add.button(0, 0, 'music_on', this.musicBtnPressed);
        this.musicBtnOn.width = this.musicBtnOn.height = gameWidth * 0.09;
        this.musicBtnOn.x = gameWidth * 0.93;
        this.musicBtnOn.y = gameHeight * 0.1;
        this.musicBtnOn.anchor.setTo(0.5);
        this.musicBtnOn.inputEnabled = true;
        this.musicBtn = this.musicBtnOn;

        this.musicBtnOff = this.game.add.button(0, 0, 'music_off', this.musicBtnPressed);
        this.musicBtnOff.width = this.musicBtnOff.height = gameWidth * 0.09;
        this.musicBtnOff.x = gameWidth * 0.93;
        this.musicBtnOff.y = gameHeight * 0.1;
        this.musicBtnOff.anchor.setTo(0.5);
        this.musicBtnOff.inputEnabled = true;
        this.musicBtnOff.visible = false;

if(!this.game.audioState){
    this.musicBtnOn.visible = false;
    this.musicBtnOff.visible = true;
    this.nusicBtn = this.musicBtnOff;
}

        // logo
        this.logo = this.game.add.button(0, 0, 'rainbow_logo', this.btnPressed);
        this.logo.name = 'logo';
        this.logo.width = gameWidth * 0.3;
        this.logo.height = gameHeight * 0.175;
        this.logo.x = gameWidth * 0.15;
        this.logo.y = gameHeight * 0.1;
        this.logo.anchor.setTo(0.5);
        this.game.logo = this.logo;

    },
    update: function(){
        // buttons hover effect
        if(this.playBtn.input.pointerOver() && !this.playBtn.hovered){
            this.playBtn.hovered = true;
            this.btnHoverBubble(this.playBtn, this.playBtnShadow);
        }
        if(!this.playBtn.input.pointerOver() && this.playBtn.hovered){
            this.playBtn.hovered = false;
            this.playBtnShadow.alpha = 0;
        }
        if(!this.playBtn.hovered){
            this.playBtnShadow.alpha = 0;
        }

        if(this.plusBtn.input.pointerOver() && !this.plusBtn.hovered){
            this.plusBtn.hovered = true;
            this.btnHoverBubble(this.plusBtn, this.plusBtnShadow);
        }
        if(!this.plusBtn.input.pointerOver() && this.plusBtn.hovered){
            this.plusBtn.hovered = false;
            this.plusBtnShadow.alpha = 0;
        }
        if(!this.plusBtn.hovered){
            this.plusBtnShadow.alpha = 0;
        }

        if(this.musicBtn.input.pointerOver() && !this.musicBtn.hovered){
            this.musicBtn.hovered = true;
            this.btnHoverBubble(this.musicBtn, this.musicBtnShadow);
        }
        if(!this.musicBtn.input.pointerOver() && this.musicBtn.hovered){
            this.musicBtn.hovered = false;
            this.musicBtnShadow.alpha = 0;
        }
        if(!this.musicBtn.hovered){
            this.musicBtnShadow.alpha = 0;
        }

        if(this.fbBtn.input.pointerOver() && !this.fbBtn.hovered){
            this.fbBtn.hovered = true;
            this.btnScaleHover(this.fbBtn, this.fbBtnShadow);
        }
        if(!this.fbBtn.input.pointerOver() && this.fbBtn.hovered){
            this.fbBtn.scale.setTo(0.5);
            this.fbBtn.hovered = false;
            this.fbBtnShadow.alpha = 0;
        }
        if(!this.fbBtn.hovered){
            this.fbBtnShadow.alpha = 0;
        }

    }
}