"use strict";
window.GirlsGame.state.try_again = {
    game: window.GirlsGame.game,
    currentTxt: 0,
    btnHoverBubble: function(el, shadow){
        var self = this;
        var stepTime = 75;
        var t = this.game.add.tween(el.scale);
        t.to({x: 0.5, y: 0.3}, stepTime, Phaser.Easing.Bounce.None);
        t.start();

        setTimeout(function(){
            var t2 = self.game.add.tween(el.scale);
            t2.to({x: 0.3, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
            t2.start();

            setTimeout(function(){
                var t3 = self.game.add.tween(el.scale);
                t3.to({x: 0.5, y: 0.5}, stepTime, Phaser.Easing.Bounce.None);
                t3.onComplete.addOnce(function(){
                    if(el.hovered && shadow){
                        var t4 = self.game.add.tween(shadow);
                        t4.to({alpha: 1}, stepTime * 3, Phaser.Easing.Linear.None);
                        t4.start();
                    }
                }, this);
                t3.start();

            }, stepTime);
        }, stepTime);

    },
    btnPressed: function(el){
        var uri = null;
        if(el.name == 'fb'){
            uri = fbUri;
        }
        if(el.name == 'logo'){
            uri = logoUri
        }
        if(el.name == 'plus'){
            uri = plusUri
        }

        var win = window.open(uri, '_blank');
        win.focus();
    },
    musicBtnPressed: function(){
        var self = window.GirlsGame.state.try_again;
        if(self.musicBtnOn.visible){
            self.musicBtnOn.visible = false;
            self.musicBtnOff.visible = true;
            self.musicBtn = self.musicBtnOff;
            self.game.audioState = false;
            self.game.bckgAudio.stop();
        }
        else{
            self.musicBtnOn.visible = true;
            self.musicBtnOff.visible = false;
            self.musicBtn = self.musicBtnOn;
            self.game.audioState = true;
            self.game.bckgAudio.play();
        }
    },
    playPressed: function(){
        var self = window.GirlsGame.state.try_again;
    
        var t = self.game.add.tween(self.game.world);
        t.to({alpha: 0}, 400, Phaser.Easing.Linear.None);
        t.start();
        setTimeout(function(){
            self.game.state.start('level3');
            self.game.world.alpha = 1;
        }, 350);
        
    },
    create: function(){
        this.currentTxt = 0;
        // background
        var bckg = this.game.add.sprite(0, 0, 'msg_bckg');
        bckg.width = gameWidth;
        bckg.height = gameHeight;

        this.playBtnShadow = this.game.add.sprite(0, 0, 'try_again_btn');
        this.playBtnShadow.width = this.playBtnShadow.height = gameWidth * 0.15;
        this.playBtnShadow.x = this.game.world.centerX;
        this.playBtnShadow.y = gameHeight * 0.85;
        this.playBtnShadow.anchor.set(0.5);
        this.playBtnShadow.scale.set(0.53);
        this.playBtnShadow.tint = 0x33FFFF;
        this.playBtnShadow.alpha = 0;

        var blurX = this.game.add.filter('BlurX');
        var blurY = this.game.add.filter('BlurY');
        this.playBtnShadow.filters = [blurX, blurY];

        var playBtn = this.game.add.button(0, 0, 'try_again_btn', this.playPressed);
        playBtn.width = playBtn.height = gameWidth * 0.15;
        playBtn.x = this.game.world.centerX;
        playBtn.y = gameHeight * 0.85;
        playBtn.anchor.setTo(0.5);
        playBtn.scale.set(0.5);
        playBtn.inputEnabled = true;
        this.playBtn = playBtn;

        this.plusBtnShadow = this.game.add.sprite(0, 0, 'plus_btn');
        this.plusBtnShadow.width = this.plusBtnShadow.height = gameWidth * 0.13;
        this.plusBtnShadow.x = gameWidth * 0.9;
        this.plusBtnShadow.y = gameHeight * 0.85;
        this.plusBtnShadow.anchor.set(0.5);
        this.plusBtnShadow.scale.set(0.53);
        this.plusBtnShadow.tint = 0x33FFFF;
        this.plusBtnShadow.alpha = 0;
        this.plusBtnShadow.filters = [blurX, blurY];

        // plus button
        this.plusBtn = this.game.add.button(0, 0, 'plus_btn', this.btnPressed);
        this.plusBtn.name = 'plus';
        this.plusBtn.width = this.plusBtn.height = gameWidth * 0.13;
        this.plusBtn.x = gameWidth * 0.9;
        this.plusBtn.y = gameHeight * 0.85;
        this.plusBtn.anchor.setTo(0.5);
        this.plusBtn.inputEnabled = true;
        this.plusBtn.input.pixelPerfectOver = true;

        // fb button
        this.fbBtn = this.game.add.button(0, 0, 'fb_btn', this.btnPressed);
        this.fbBtn.name = 'fb';
        this.fbBtn.width = this.fbBtn.height = gameWidth * 0.07;
        this.fbBtn.x = gameWidth * 0.84;
        this.fbBtn.y = gameHeight * 0.1;
        this.fbBtn.anchor.setTo(0.5);
        this.fbBtn.inputEnabled = true;

        // music button
        this.musicBtnOn = this.game.add.button(0, 0, 'music_on', this.musicBtnPressed);
        this.musicBtnOn.width = this.musicBtnOn.height = gameWidth * 0.09;
        this.musicBtnOn.x = gameWidth * 0.93;
        this.musicBtnOn.y = gameHeight * 0.1;
        this.musicBtnOn.anchor.setTo(0.5);
        this.musicBtnOn.inputEnabled = true;
        this.musicBtn = this.musicBtnOn;

        this.musicBtnOff = this.game.add.button(0, 0, 'music_off', this.musicBtnPressed);
        this.musicBtnOff.width = this.musicBtnOff.height = gameWidth * 0.09;
        this.musicBtnOff.x = gameWidth * 0.93;
        this.musicBtnOff.y = gameHeight * 0.1;
        this.musicBtnOff.anchor.setTo(0.5);
        this.musicBtnOff.inputEnabled = true;
        this.musicBtnOff.visible = false;

if(!this.game.audioState){
    this.musicBtnOn.visible = false;
    this.musicBtnOff.visible = true;
    this.nusicBtn = this.musicBtnOff;
}

        // logo
        this.logo = this.game.add.button(0, 0, 'rainbow_logo', this.btnPressed);
        this.logo.name = 'logo';
        this.logo.width = gameWidth * 0.3;
        this.logo.height = gameHeight * 0.175;
        this.logo.x = gameWidth * 0.15;
        this.logo.y = gameHeight * 0.1;
        this.logo.anchor.setTo(0.5);
        this.game.logo = this.logo;

        // intro text
        this.txt = this.game.add.sprite(0, 0, 'try_again');
        this.txt.scale.set(0.5);
        this.txt.x = gameWidth * 0.542;
        this.txt.y = gameHeight * 0.344;
        this.txt.anchor.setTo(0.5);

    },
    update: function(){
        // buttons hover effect
        if(this.playBtn.input.pointerOver() && !this.playBtn.hovered){
            this.playBtn.hovered = true;
            this.btnHoverBubble(this.playBtn, this.playBtnShadow);
        }
        if(!this.playBtn.input.pointerOver() && this.playBtn.hovered){
            this.playBtn.hovered = false;
            this.playBtnShadow.alpha = 0;
        }
        if(!this.playBtn.hovered){
            this.playBtnShadow.alpha = 0;
        }

        if(this.plusBtn.input.pointerOver() && !this.plusBtn.hovered){
            this.plusBtn.hovered = true;
            this.btnHoverBubble(this.plusBtn, this.plusBtnShadow);
        }
        if(!this.plusBtn.input.pointerOver() && this.plusBtn.hovered){
            this.plusBtn.hovered = false;
            this.plusBtnShadow.alpha = 0;
        }
        if(!this.plusBtn.hovered){
            this.plusBtnShadow.alpha = 0;
        }

        if(this.musicBtn.input.pointerOver() && !this.musicBtn.hovered){
            this.musicBtn.hovered = true;
            this.btnHoverBubble(this.musicBtn);
        }
        if(!this.musicBtn.input.pointerOver() && this.musicBtn.hovered){
            this.musicBtn.hovered = false;
        }
    }
}